﻿using System;
using System.Data;
using System.Configuration;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net.Mail;
using System.Globalization;
using System.Threading;
using System.Resources;
using System.IO;
using System.Collections;

public partial class Masters_TA_UI_Master_LoanEntryList : Base.BasePage
{

    #region "Variable Declaration"
    ResourceManager rm;
    CultureInfo ci;
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    LeaveApplicationEventData objLeaveHolidays = new LeaveApplicationEventData();
    PayrollConfigurationEventData objPayrollEventData = new PayrollConfigurationEventData();
    EmployeeEventData objEmployee = new EmployeeEventData();
    cls_Common objClassCommon = new cls_Common();
    //DataSet dsLeaveHolidays = new DataSet();
    DataSet ds_Year = new DataSet();
    //LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    PermissionEventData objPermissionEventData = new PermissionEventData();
    DataSet ds_LoanDetails = new DataSet();
    string strScript = string.Empty;
    int StartYear, EndYear; string source_Language;
     int iLoanEntry_Id, iEmployeeID, YearSettingID;

    int payrollConfig = 0;
    #endregion


    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        if (!Page.IsPostBack)
        {
            grv_LoanRegister.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
            base.CheckPages(0);
            objClassCommon.menu("PayrollMaster", "316");
            UserRights();
            LoadStrings(ci);
            btn_Add.Focus();
            BindingEmployeeCategoryandType();
            string strSetAlert = "";
            strSetAlert = strSetAlert + "<script language='javascript'>";
            strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
            strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_FillDetails", ci) + "','" + rm.GetString("Alert_FillFromToDate", ci) + "');";
            strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
            strSetAlert = strSetAlert + "</script>";
            Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
            ds_Year = objClassCommon.GetYearsetting();
            if (ds_Year.Tables[0].Rows.Count <= 0)
            {
                string strScript = string.Empty;
                strScript = strScript + "<script language='javascript'>";
                strScript = strScript + "alert('" + rm.GetString("Msg_DefineYearSettinginOrganizationSettings", ci) + "');location.replace('../Organization Settings/Organization_YearSetting.aspx')";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("AlertLeavePolicyYear", strScript);
            }
            else
            {

                StartYear = Convert.ToInt32(ds_Year.Tables[0].Rows[0]["StartYear"]);
                EndYear = Convert.ToInt32(ds_Year.Tables[0].Rows[0]["EndYear"]);
                ViewState["YearSettings_Id"] = Convert.ToString(ds_Year.Tables[0].Rows[0]["YearSettings_Id"]);
                ds_Year.Dispose();
            }
            //BindLeaveApplication();
            //Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
            //Hidden2.Value = Convert.ToString(Session["ITimeFormat"]);
            BindControlsBasedOnLicense();

        }
        BindLoanEntry();
        //if (Convert.ToString(ViewState["GroupName"]) == "Normal")
        //{
        //    trSwipeCardNo.Visible = false;
        //    trEmployeeDetails.Visible = false;
        //}
        //if (ViewState["vs_payrollConfig"] != null)
        //{
        //    payrollConfig = (int)ViewState["vs_payrollConfig"];
        //}
        //else
        //{
        //    payrollConfig = objClassCommon.CheckPageExistsInLicense(185);
        //}
        //if (payrollConfig == 1)
        //{
        //    grv_LoanRegister.Columns[10].Visible = false;
        //    grv_LoanRegister.Columns[11].Visible = true;
        //    grv_LoanRegister.Columns[12].Visible = false;
        //}


    }
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(316, Convert.ToInt32(Session["userGroup_Id"]), "");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["addPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["addPrv"]) == 1)
            {
                this.btn_Add.Visible = true;
               // btnImport.Visible = true;
            }
            else
            {
                this.btn_Add.Visible = false;
                //btnImport.Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 1)
            {
                //if (payrollConfig == 1)
                //{
                //    this.grv_LoanRegister.Columns[12].Visible = true;
                //    this.grv_LoanRegister.Columns[11].Visible = false;
                //}
                //else
                //{
                //    this.grv_LoanRegister.Columns[12].Visible = false;
                //    this.grv_LoanRegister.Columns[11].Visible = true;
                //}
            }
            else
            {
                //if (payrollConfig == 1)
                //{
                //    this.grv_LoanRegister.Columns[12].Visible = false;
                //    this.grv_LoanRegister.Columns[11].Visible = false;
                //}
                //else
                //{
                //    this.grv_LoanRegister.Columns[12].Visible = false;
                //    this.grv_LoanRegister.Columns[11].Visible = false;
                //}
            }
            if (ds_Checkuser.Tables[0].Rows[0]["deletePrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["deletePrv"]) == 1)
            {
                this.grv_LoanRegister.Columns[10].Visible = true;
            }
            else
            {
                this.grv_LoanRegister.Columns[11].Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["addPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["addPrv"]) == 0 &&
                ds_Checkuser.Tables[0].Rows[0]["deletePrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["deletePrv"]) == 0 &&
                ds_Checkuser.Tables[0].Rows[0]["viewPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 0)
            {
                Response.Redirect("TransactionLandingPage.aspx");
            }
        }
        else
        {
            Response.Redirect("TransactionLandingPage.aspx");
        }
        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
        {
            //lnktbnexcel.Visible = true;
            //lnkbtnpdf.Visible = true;
        }
    }

    private void LoadStrings(CultureInfo ci)
    {
        lblEmpCategory.Text = rm.GetString("lblEmpCategory", ci);
        lblEmpType.Text = rm.GetString("lblEmpType", ci);
        lblGender.Text = rm.GetString("EmployeeMaster_Gender", ci);
        lbl_Header.Text = rm.GetString("Master_LoanEntry", ci);
        lbl_EmployeeName.Text = rm.GetString("email_EmployeeName", ci);
        lbl_EmployeeId.Text = rm.GetString("email_EmployeeId", ci);
        //lblTimePeriod.Text = rm.GetString("ShiftExchange_DateRange", ci);
        //lblLeaveStartDate.Text = rm.GetString("email_FromDate", ci);
        //lblLeaveEndDate.Text = rm.GetString("email_ToDate", ci);
        //lblTimePeriod.Text = rm.GetString("ShiftExchange_DateRange", ci);
        btn_Search.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Search", ci);
        btn_Clear.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Clear", ci);
        btn_Add.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Add", ci);
        btn_PermanentDelete.Text = "&nbsp;&nbsp" + rm.GetString("btn_Delete", ci);
        grv_LoanRegister.Columns[1].Caption = rm.GetString("Loan_ID", ci);
        grv_LoanRegister.Columns[2].Caption = rm.GetString("email_EmployeeId", ci);
        grv_LoanRegister.Columns[3].Caption = rm.GetString("email_EmployeeName", ci);
        grv_LoanRegister.Columns[4].Caption = rm.GetString("loan_Amount", ci);
        grv_LoanRegister.Columns[5].Caption = rm.GetString("Loan_DurationMonths", ci);
        grv_LoanRegister.Columns[6].Caption = rm.GetString("loan_DeductStart_Month", ci);
        grv_LoanRegister.Columns[7].Caption = rm.GetString("Loan_MonthlyPayoff", ci);
        grv_LoanRegister.Columns[8].Caption = rm.GetString("loanBalanceAmount", ci);
        grv_LoanRegister.Columns[9].Caption = rm.GetString("Loan_Description", ci);
        //lblEmpSwipe.Text = rm.GetString("TerminalDataType_Card_No", ci);
        //lblFilter.Text = rm.GetString("lblFilter", ci);
        lblDataView.Text = rm.GetString("lblDataView", ci);
        //btnImport.Text = rm.GetString("btnImport", ci);
    }

    private void BindLoanEntry()
    {
        Hashtable htable = new Hashtable();
        htable.Add("@tag","S");
        ds_LoanDetails = objPayrollEventData.InsertLoanDetails(htable);
        grv_LoanRegister.DataSource = ds_LoanDetails;
        grv_LoanRegister.DataBind();
       
    }

    private void BindControlsBasedOnLicense()
    {
        #region Eastman
        if (Convert.ToString(Session["packageID"]) != "")
            if (Convert.ToString(Session["packageID"]) == "155") /*EastMan*/
            {
                if (Convert.ToString(Session["IndividualUsers"]) != "True")
                {
                    iframePopup.Attributes.Add("height", "600");
                }
            }
            else if (Convert.ToInt32(Session["packageID"]) >= 164) /*TimecheckV2.9_Enterprice*/
            {
                // for individual user it not be loaded. import option.
                if (Convert.ToString(Session["IndividualUsers"]) == "True")
                {
                  //  btnImport.Style.Add("display", "none");
                }
            }
        #endregion
    }

    protected void btn_delete_Click(object sender, EventArgs e)
    {
        LinkButton btn = sender as LinkButton;
        iLoanEntry_Id = Convert.ToInt32(btn.CommandName);
        Hashtable htable = new Hashtable();
        htable.Add("@loanId", iLoanEntry_Id);
        htable.Add("@tag", "D");
        objPayrollEventData.InsertLoanDetails(htable);
        DeleteAlertMessage();
    
    }
    protected void btn_Cancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_MasterLeaveMain.aspx");
    }
    protected void btn_PermanentDelete_Click(object sender, EventArgs e)
    {
        if (hdnSelectRow.Value != string.Empty && hdnSelectRow.Value != null)
        {
            Hashtable dHashTable = new Hashtable();
            dHashTable.Add("@Type", "PermanentDeleteLoan");
            dHashTable.Add("@PolicyId", hdnSelectRow.Value);
            DataSet ds = objPayrollEventData.PermanentDeletePolicy(dHashTable);
            base.MessageWithRedirect("Record Sucessfully Deleted", "TA_UI_Master_LoanEntryList.aspx");
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("DeletionRecordAlert", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }

    private void DeleteAlertMessage()
    {
        string strScript = "";
        strScript = strScript + "<script language='javascript'>";
        strScript = strScript + "alert('" + rm.GetString("Alert_LoanDetailDeleted", ci) + "');";
        strScript = strScript + "location.replace('TA_UI_Master_LoanEntryList.aspx');";
        strScript = strScript + "</script>";
        //Dispaly alert messsage.
        Page.RegisterStartupScript("AlertLDel65507866", strScript);
        return;
    }

    protected void EditLinkButton_Click(object sender, EventArgs e)
    {

        LinkButton btn = sender as LinkButton;
        int gintManualTimeEntryId = Convert.ToInt32(btn.CommandName);
        string ManuStatus = btn.CommandArgument;
        //if (ManuStatus == "Approved")
        //{
        //    if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
        //    {
        //        Response.Redirect("../Transactions/TA_UI_Master_LoanEntryModify.aspx?MID=" + gintManualTimeEntryId);
        //    }
        //    else
        //    {
        //        base.Message(rm.GetString("Msg_ApprovedManualTimeEntryCannotbemodified", ci));
        //        return;
        //    }
        //}
        Response.Redirect("../Masters/TA_UI_Master_LoanEntryModify.aspx?LoanId=" + gintManualTimeEntryId);
    }

    protected void btnImport_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Transactions_LeaveImport.aspx");
    }
    protected void lnktbnexcel_Click(object sender, EventArgs e)
    {
        LinkButton lnkbtn = (LinkButton)sender;  //Called From  Grid Report Icon click / both excel and pdf
        DisableControls();
        ASPxGridViewExporter1.Landscape = true;
        ASPxGridViewExporter1.LeftMargin = 10;
        ASPxGridViewExporter1.RightMargin = 10;
        ASPxGridViewExporter1.ExportedRowType = DevExpress.Web.GridViewExportedRowType.All;
        ASPxGridViewExporter1.MaxColumnWidth = 400;
        string saveAsFileName = string.Format("ListofLeaveApplications - {0:d}", DateTime.Now).Replace("/", "-").Replace(" ", "");
        ASPxGridViewExporter1.FileName = saveAsFileName;
        ASPxGridViewExporter1.PaperKind = System.Drawing.Printing.PaperKind.A3;
        switch (lnkbtn.CommandName)
        {
            case "excel":
                ASPxGridViewExporter1.WriteXlsxToResponse();
                break;
            case "pdf":
                ASPxGridViewExporter1.WritePdfToResponse();
                break;
            case "csv":
                ASPxGridViewExporter1.WriteCsvToResponse();
                break;
        }
    }
    private void DisableControls()
    {
        grv_LoanRegister.Columns[9].Visible = false;
        grv_LoanRegister.Columns[10].Visible = false;
        //GridView1.Columns[15].Visible = false;
    }
    protected void Timer1_Tick(object sender, EventArgs e)
    {
       // BindLeaveApplication();
    }
  
    

    protected void btn_Add_Click(object sender, EventArgs e)
    {
        /*Below parameter is used for Angler 1 ! 0*/
        if (payrollConfig == 1)
        {
            Response.Redirect("TA_UI_Transactions_MultipleLeaveApplicationAdd.aspx");
        }
        else
        {
            Response.Redirect("TA_UI_Master_LoanApplicationAdd.aspx");
        }
    }
    protected void btn_Clear_Click(object sender, EventArgs e)
    {
        grid_RestoreDefault();
        lbl_Error.Text = string.Empty;
    }
    protected void btn_Search_Click(object sender, EventArgs e)
    {
        FillGrid_Search();
    }
    protected void grv_LoanRegister_HtmlRowCreated(object sender, DevExpress.Web.ASPxGridViewTableRowEventArgs e)
    {
        base.Page_Load(sender, e);
        if (e.RowType == DevExpress.Web.GridViewRowType.Data)
        {
            source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
            rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
            ci = Thread.CurrentThread.CurrentCulture;
           // string appdate = Convert.ToString(e.GetValue("Leave_ApplicationDate"));
            Label lbl_Status = (Label)grv_LoanRegister.FindRowCellTemplateControl(e.VisibleIndex, null, "lbl_Status");
            if (lbl_Status != null)
            {
                switch (lbl_Status.Text)
                {
                    case "Approved":
                        lbl_Status.Text = rm.GetString("btn_Approved", ci);
                        break;
                    case "Forwarded":
                        lbl_Status.Text = rm.GetString("btn_Forwarded", ci);
                        break;
                    case "Pending":
                        lbl_Status.Text = rm.GetString("btn_Pending", ci);
                        break;
                    case "Rejected":
                        lbl_Status.Text = rm.GetString("btn_Reject", ci);
                        break;
                    default:
                        break;
                }
            }
            Label lbl_LeaveType = (Label)grv_LoanRegister.FindRowCellTemplateControl(e.VisibleIndex, null, "lbl_LeaveType");
            if (lbl_LeaveType != null)
            {
                switch (lbl_LeaveType.Text)
                {
                    case "Restricted Holiday":
                        lbl_LeaveType.Text = rm.GetString("Holiday_RestrictedHoliday", ci);
                        break;
                    case "Comp Off":
                        lbl_LeaveType.Text = rm.GetString("Caption_CompOff", ci);
                        break;
                    case "ESI":
                        lbl_LeaveType.Text = rm.GetString("Caption_ESI", ci);
                        break;
                    default:
                        if (lbl_LeaveType.Text.Contains("LOP"))
                        {
                            lbl_LeaveType.Text = lbl_LeaveType.Text.Replace("LOP", rm.GetString("lbl_LOP", ci));
                        }
                        else if (lbl_LeaveType.Text.Contains("Leave"))
                        {
                            lbl_LeaveType.Text = lbl_LeaveType.Text.Replace("Leave", rm.GetString("LeaveApplication_Leave", ci));
                        }
                        break;
                }
            }
        }
    }
    protected void btn_Restore_Click(object sender, EventArgs e)
    {
        if (hdnSelectRow.Value != string.Empty && hdnSelectRow.Value != null)
        {
            //string[] LeavePolicyIDs;
            //LeavePolicyIDs = objLeave.commaStringToArray(hdnSelectRow.Value);
            //for (int i = 0; i < LeavePolicyIDs.Length; i++)
            //{
            //    DataSet ds = objLeave.CheckLeavePolicyDuplicate(Convert.ToInt32(LeavePolicyIDs[i]));
            //    if (Convert.ToInt32(ds.Tables[0].Rows[0]["Count"]) > 0 || Convert.ToInt32(ds.Tables[0].Rows[0]["Count1"]) > 0)
            //    {
            //        if (Convert.ToInt32(ds.Tables[0].Rows[0]["Count"]) > 0)
            //        {
            //            base.Message(rm.GetString("Message_Cannot_Restore_LeavePolicy", ci));
            //            // grv_LeavePolicy.DataBind();
            //            hdnSelectRow.Value = "";
            //            return;
            //        }
            //        if (Convert.ToInt32(ds.Tables[0].Rows[0]["Count1"]) > 0)
            //        {
            //            base.Message(rm.GetString("Message_Cannot_Restore", ci));
            //            // grv_LeavePolicy.DataBind();
            //            hdnSelectRow.Value = "";
            //            return;
            //        }
            //    }
            //}
            //  objLeave.RestoreLeavePolicies(hdnSelectRow.Value, EmployeeID);
            base.MessageWithRedirect(rm.GetString("Alert_LeavePolicyrestoredsuccessfully", ci), "TA_UI_MasterLeavePolicyList.aspx");
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("DeletionRecordAlert", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }
    private void grid_RestoreDefault()
    {
        //txt_EmpName.Text = string.Empty;
        //txtEmployeeId.Text = string.Empty;
        //txtLeaveStartDate.Text = string.Empty;
        //txtLeaveEndDate.Text = string.Empty;
        //txtSwipeCard.Text = string.Empty;
        grv_LoanRegister.PageIndex = 0;
        //if (payrollConfig == 1)
        //{
        //    if (Convert.ToString(ViewState["GroupName"]) == "SuperAdmin")
        //    {
        //        grv_LoanRegister.DataSourceID = ObjectDataSource4.ID;
        //    }
        //    else
        //    {
        //        grv_LoanRegister.DataSourceID = ObjectDataSource3.ID;
        //    }
        //}
        //else
        //{
        //    if (Convert.ToString(ViewState["GroupName"]) == "SuperAdmin")
        //    {
        //        grv_LoanRegister.DataSourceID = ObjectDataSource2.ID;
        //    }
        //    else
        //    {
        //        grv_LoanRegister.DataSourceID = ObjectDataSource1.ID;
        //    }
        //}
    }

    private void BindingEmployeeCategoryandType()
    {
        // employee category binding
        DataSet dsCategory = new DataSet();
        dsCategory = objEmployee.SelectCategoryDetailsEmployee("");
        if (dsCategory != null)
        {
            if (dsCategory.Tables[0].Rows.Count > 0)
            {
                ddlEmpCatagory.DataSource = dsCategory;
                ddlEmpCatagory.DataTextField = "CategoryName";
                ddlEmpCatagory.DataValueField = "CategoryId";
                ddlEmpCatagory.DataBind();
            }
            dsCategory.Dispose();
            foreach (ListItem item in ddlEmpCatagory.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
        // employee type binding
        DataSet dsType = new DataSet();
        dsType = objEmployee.SelectTypeDetailsEmployee("");
        if (dsType != null)
        {
            if (dsType.Tables[0].Rows.Count > 0)
            {
                ddlEmpType.DataSource = dsType;
                ddlEmpType.DataTextField = "TypeName";
                ddlEmpType.DataValueField = "TypeId";
                ddlEmpType.DataBind();
            }
            dsType.Dispose();
            foreach (ListItem item in ddlEmpType.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
    }
    private void FillGrid_Search()
    {
        DataSet dsEmployee = new DataSet();

        string empName = txt_EmpName.Text.Trim();
        txt_EmpName.Text = empName;
        string empId = txtEmployeeId.Text.Trim();
        txtEmployeeId.Text = empId;
       
        bool boolErrorStatus = true;
        string gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
       
        string strSwipeCard = "";
        strSwipeCard = Convert.ToString(txtSwipeCard.Text).Trim().Replace("'", "''");
      
        //else if (strLeaveStartDate != string.Empty && strLeaveEndDate != string.Empty)
        //{
        //    if (Convert.ToDateTime(strLeaveEndDate).Date < Convert.ToDateTime(strLeaveStartDate).Date)
        //    {
        //        base.Message(rm.GetString("Alert_FromDateLessThanToDate"));
        //        boolErrorStatus = true;
        //        grv_LoanRegister.DataSourceID = "";
        //        return;
        //    }
        //    else
        //    {
        //        boolErrorStatus = false;
        //    }
        //}
        if (boolErrorStatus == true)
        {
            grid_RestoreDefault();
        }
        //else
        //{
        //    lbl_Error.Text = string.Empty;
        //    grv_LoanRegister.PageIndex = 0;
        //    if (payrollConfig == 1)
        //    {
        //        if (Convert.ToString(ViewState["GroupName"]) == "SuperAdmin")
        //        {
        //            grv_LoanRegister.DataSourceID = ObjectDataSource4.ID;
        //        }
        //        else
        //        {
        //            grv_LoanRegister.DataSourceID = ObjectDataSource3.ID;
        //        }
        //    }
        //    else
        //    {
        //        if (Convert.ToString(ViewState["GroupName"]) == "SuperAdmin")
        //        {
        //            grv_LoanRegister.DataSourceID = ObjectDataSource2.ID;
        //        }
        //        else
        //        {
        //            grv_LoanRegister.DataSourceID = ObjectDataSource1.ID;
        //        }
        //    }
        //}
    }
}