using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Resources;
using System.Globalization;
using System.Threading;
using System.IO;

public partial class Reports_TA_Popup_Report_MasterPage : System.Web.UI.MasterPage
{
    ResourceManager rm;
    protected void Page_Load(object sender, EventArgs e)
    {
        loadcss();
    }

    private void loadcss()
    {
        CultureInfo ci;
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        //if Standard Demo
        MasReportHtml.Attributes.Add("dir", rm.GetString("Direction", ci));
        if (source_Language == "Resources.Resource_AR")
        {
            stylebootstrap.Href = "../bootstrap/css/bootstrap-rtl.min.css";
            stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome-rtl.css";
            stylebuild.Href = "../bootstrap/font-awesome/css/build-rtl.css";
            stylejvectormap.Href = "../plugins/jvectormap/jquery-jvectormap-1.2.2-rtl.css";
            styleAdminLTE.Href = "../dist/css/AdminLTE.min-rtl.css";
            styleallskins.Href = "../dist/css/_all-skins.min-rtl.css";
            stylecustom.Href = "../dist/css/custom-rtl.css";
            stylefonts.Href = "../dist/css/fonts.css";
            styledatepicker3.Href = "../plugins/datepicker/datepicker3-rtl.css";
            styledaterangepicker.Href = "../plugins/daterangepicker/daterangepicker-bs3-rtl.css";
            styleProgressBar.Href = "../css/ProgressBar-rtl.css";
            styleselect2.Href = "../plugins/select2/select2.min-rtl.css";
            styleAutocomp.Href = "../bootstrap/css/autoCompleteNew-rtl.css";
            Session["GridCSS"] = "../bootstrap/css/GridView-rtl.css";
            Session["SiteMapProvider"] = "Arabic";
        }
        else
        {
            //MasHtml.Attributes.Add("dir", "rtl");
            //stylebootstrap.Href = "../bootstrap/css/bootstrap-rtl.min.css";
            //stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome-rtl.css";
            //stylebuild.Href = "../bootstrap/font-awesome/css/build-rtl.css";
            //stylejvectormap.Href = "../plugins/jvectormap/jquery-jvectormap-1.2.2-rtl.css";
            //styleAdminLTE.Href = "../dist/css/AdminLTE.min-rtl.css";
            //styleallskins.Href = "../dist/css/_all-skins.min-rtl.css";
            //stylecustom.Href = "../dist/css/custom-rtl.css";
            //stylefonts.Href = "../dist/css/fonts.css";
            //styledatepicker3.Href = "../plugins/datepicker/datepicker3-rtl.css";
            //styledaterangepicker.Href = "../plugins/daterangepicker/daterangepicker-bs3-rtl.css";
            //styleProgressBar.Href = "../css/ProgressBar-rtl.css";
            //styleselect2.Href = "../plugins/select2/select2.min-rtl.css";
            //Session["GridCSS"] = "../bootstrap/css/GridView-rtl.css";
            //Session["SiteMapProvider"] = "Arabic";
            stylebootstrap.Href = "../bootstrap/css/bootstrap.min.css";
            stylefontawesome.Href = "../bootstrap/font-awesome/css/font-awesome.css";
            stylebuild.Href = "../bootstrap/font-awesome/css/build.css";
            stylejvectormap.Href = "../plugins/jvectormap/jquery-jvectormap-1.2.2.css";
            styleAdminLTE.Href = "../dist/css/AdminLTE.min.css";
            styleallskins.Href = "../dist/css/_all-skins.min.css";
            stylecustom.Href = "../dist/css/custom.css";
            stylefonts.Href = "../dist/css/fonts.css";
            styledatepicker3.Href = "../plugins/datepicker/datepicker3.css";
            styledaterangepicker.Href = "../plugins/daterangepicker/daterangepicker-bs3.css";
            styleProgressBar.Href = "../css/ProgressBar.css";
            styleselect2.Href = "../plugins/select2/select2.min.css";
            styleAutocomp.Href = "../bootstrap/css/autoCompleteNew.css";
            Session["GridCSS"] = "../bootstrap/css/GridView.css";
            Session["SiteMapProvider"] = "English";
        }
    }

}
