﻿using System;
using System.Collections.Generic;
using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Globalization;
using System.Threading;
using System.Resources;
using System.IO;

public partial class Transactions_TA_UI_Transaction_TransferAdd : Base.BasePage
{
    #region "Variable Declaration"
    ResourceManager rm;
    CultureInfo ci;
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    EmployeeEventData objEmployee = new EmployeeEventData();
    LeaveApplicationEventData objLeaveHolidays = new LeaveApplicationEventData();
    cls_Common objClassCommon = new cls_Common();
    DataSet dsLeaveHolidays = new DataSet();
    DataSet ds_Year = new DataSet();
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    PermissionEventData objPermissionEventData = new PermissionEventData();
    DataSet dsEmailIdOfSanctionAuthority = new DataSet();
    DataSet ds_EmailIdOfReportingTo = new DataSet();
    DataSet ds_EmployeeDetails = new DataSet();
    int StartYear, EndYear; string source_Language;
    int iLeaveApplication_Id, iEmployeeID, YearSettingID;
    string strReason = string.Empty, strEmailIdReportingTo, gstrDateFormat, gstrTimeFormat, strlevelName, strStatusType;
    Boolean blnCheckEmail;
    DataSet dsEmployeeGroup = new DataSet();
    int payrollConfig = 0;
    #endregion
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
            objClassCommon.menu("LeaveTransaction", "22");
            UserRights();
            LoadStrings(ci);
            txtEntryDate.Text = DateTime.Now.ToString(Convert.ToString(Session["MDateFormat"]) + " HH:mm:ss tt");
            BindDesignation();
            BindReportingToApprovalAuthority();
            string strSetAlert = "";
            strSetAlert = strSetAlert + "<script language='javascript'>";
            strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
            strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_FillDetails", ci) + "','" + rm.GetString("Alert_FillFromToDate", ci) + "');";
            strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
            strSetAlert = strSetAlert + "</script>";
            Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
            ds_Year = objClassCommon.GetYearsetting();
            if (ds_Year.Tables[0].Rows.Count <= 0)
            {
                string strScript = string.Empty;
                strScript = strScript + "<script language='javascript'>";
                strScript = strScript + "alert('" + rm.GetString("Msg_DefineYearSettinginOrganizationSettings", ci) + "');location.replace('../Organization Settings/Organization_YearSetting.aspx')";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("AlertLeavePolicyYear", strScript);
            }
            else
            {
                StartYear = Convert.ToInt32(ds_Year.Tables[0].Rows[0]["StartYear"]);
                EndYear = Convert.ToInt32(ds_Year.Tables[0].Rows[0]["EndYear"]);
                ViewState["YearSettings_Id"] = Convert.ToString(ds_Year.Tables[0].Rows[0]["YearSettings_Id"]);
                ds_Year.Dispose();
            }
        }
    }
    protected void btn_Save_Click(object sender, EventArgs e)
    {

    }

    protected void btn_Back_Click(object sender, EventArgs e)
    {

    }
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(22, Convert.ToInt32(Session["userGroup_Id"]), "");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
        }
    }
    private void LoadStrings(CultureInfo ci)
    {
        lbl_Header.Text = "Transfer";
        lbl_EmployeeName.Text = rm.GetString("email_EmployeeName", ci);
        lbl_EmployeeId.Text = rm.GetString("email_EmployeeId", ci);
        btn_Search.Text = "&nbsp;&nbsp;";
        btn_Back.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Clear", ci);
        btn_Save.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Add", ci);
        lbl_IndicatesMandatoryFields.Text = rm.GetString("IndicatesMandatoryFields", ci);
    }
    private void BindReportingToApprovalAuthority()
    {
        DataSet ds_Reporting = new DataSet();
        ds_Reporting = objEmployee.SelectReportingPersonReport();
        if (ds_Reporting != null)
        {
            if (ds_Reporting.Tables[0].Rows.Count > 0)
            {
                ddl_ReportingTo.DataSource = ds_Reporting;
                ddl_ReportingTo.DataTextField = "Employee_FirstName";
                ddl_ReportingTo.DataValueField = "Employee_Id";
                ddl_ReportingTo.DataBind();
                ddl_LeaveSancAuthority.DataSource = ds_Reporting;
                ddl_LeaveSancAuthority.DataTextField = "Employee_FirstName";
                ddl_LeaveSancAuthority.DataValueField = "Employee_Id";
                ddl_LeaveSancAuthority.DataBind();
            }
        }
        BindTooltip(ddl_LeaveSancAuthority);
        BindTooltip(ddl_ReportingTo);
    }
    private void BindTooltip(DropDownList ddl)
    {
        foreach (ListItem item in ddl.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    private void BindDesignation()
    {
        DataSet ds_designation = new DataSet();
        ds_designation = objEmployee.select_CommonDesignation();
        if (ds_designation != null)
        {
            if (ds_designation.Tables[0].Rows.Count > 0)
            {
                ddl_Designation.DataSource = ds_designation;
                ddl_Designation.DataTextField = "TitleName";
                ddl_Designation.DataValueField = "TitleId";
                ddl_Designation.DataBind();
            }
            ds_designation.Dispose();
        }
        foreach (ListItem item in ddl_Designation.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
        BindTooltip(ddl_Designation);
    }
}