using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
using System.Net.Mail;
using System.Configuration;
/// <summary>
/// Summary description for cls_Common
/// </summary>
public class cls_Common
{
    DataAccess objDataAccess = new DataAccess();
    Database db = DatabaseFactory.CreateDatabase("DBConnection");
    DataSet ds_CheckPassword, ds_changePassword;
    string strFileName = "";
    byte[] image;
    string str = "";
    string str1 = "";
    string str2 = "";
    public byte[] ConvertByte(FileUpload fp)
    {
        strFileName = fp.PostedFile.FileName;
        FileStream fs = new FileStream(strFileName, FileMode.Open);
        BinaryReader br_reader = new BinaryReader(fs);
        image = br_reader.ReadBytes((int)fs.Length);
        fs.Close();
        br_reader.Close();
        return image;
    }
    public void menu(string url, string requestPageTitle)
    {
        if (Convert.ToString(HttpContext.Current.Session["TopMenuPrevious"]) != string.Empty)
        {
            string menulist = Convert.ToString(HttpContext.Current.Session["TopMenuPrevious"]);
            menulist = menulist.Replace("class='active'", " ");
            if (Convert.ToString(requestPageTitle) != "")
            {
                if (requestPageTitle == "27")
                {
                    menulist = menulist.Replace("id='27'", "id='27' class='active'");
                }
                else if (requestPageTitle == "71")
                {
                    menulist = menulist.Replace("id='71'", "id='71' class='active'");
                }
                else if (requestPageTitle == "62")
                {
                    menulist = menulist.Replace("id='62'", "id='62' class='active'");
                }
                else if (requestPageTitle == "70")
                {
                    menulist = menulist.Replace("id='70'", "id='70' class='active'");
                }
                else
                {
                    menulist = menulist.Replace("id='" + requestPageTitle + "'", "id='" + requestPageTitle + "' class='active'");
                }
            }
            if ((url != "Dashboard" && url != "Dashboard_Samsung") || url == "Masters_EmailConfiguration" || url == "Menu_help")
            {
                menulist = menulist.Replace("Masters/", "../Masters/");
                menulist = menulist.Replace("Transactions/", "../Transactions/");
                menulist = menulist.Replace("Reports/", "../Reports/");
                menulist = menulist.Replace("Organization Settings/", "../Organization Settings/");
                menulist = menulist.Replace("System Settings/", "../System Settings/");
                menulist = menulist.Replace("DashBoard.aspx", "../DashBoard.aspx");
                menulist = menulist.Replace("Dashboard_Samsung.aspx", "../Dashboard_Samsung.aspx");
                menulist = menulist.Replace("MyCalendar.aspx", "../MyCalendar.aspx");
                menulist = menulist.Replace("Help/", "../Help/");
                menulist = menulist.Replace("<img class='icon' src='dist/img/cogs.png'>", "<img class='icon' src='../dist/img/cogs.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/org-set.png'>", "<img class='icon' src='../dist/img/org-set.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/dev-man.png'>", "<img class='icon' src='../dist/img/dev-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/emp-man.png'>", "<img class='icon' src='../dist/img/emp-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/sit-man.png'>", "<img class='icon' src='../dist/img/sit-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/lep-man.png'>", "<img class='icon' src='../dist/img/lep-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/mte.png'>", "<img class='icon' src='../dist/img/mte.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/pri-man.png'>", "<img class='icon' src='../dist/img/pri-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/hol-man.png'>", "<img class='icon' src='../dist/img/hol-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/rep.png'>", "<img class='icon' src='../dist/img/rep.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/ouf.png'>", "<img class='icon' src='../dist/img/ouf.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/overtime.png'>", "<img class='icon' src='../dist/img/overtime.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/OnDuty.png'>", "<img class='icon' src='../dist/img/OnDuty.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/export.png'>", "<img class='icon' src='../dist/img/export.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/payroll.png'>", "<img class='icon' src='../dist/img/payroll.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/EMail.png'>", "<img class='icon' src='../dist/img/EMail.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/Dashboard.png'>", "<img class='icon' src='../dist/img/Dashboard.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/MyCalendar.png'>", "<img class='icon' src='../dist/img/MyCalendar.png'>");
                menulist = menulist.Replace("<img class='icon' src='dist/img/help.png'>", "<img class='icon' src='../dist/img/help.png'>");
               
                menulist = menulist.Replace("<img class='icon' src='dist/img/Dashboard_LegalWorkingHours.png'>", "<img class='icon' src='../dist/img/Dashboard_LegalWorkingHours.png'>");
            }
            else
            {
                menulist = menulist.Replace("../Masters/", "Masters/");
                menulist = menulist.Replace("../Transactions/", "Transactions/");
                menulist = menulist.Replace("../Reports/", "Reports/");
                menulist = menulist.Replace("../Organization Settings/", "Organization Settings/");
                menulist = menulist.Replace("../System Settings/", "System Settings/");
                menulist = menulist.Replace("../DashBoard.aspx", "DashBoard.aspx");
                menulist = menulist.Replace("../Dashboard_Samsung.aspx", "Dashboard_Samsung.aspx");
                menulist = menulist.Replace("../MyCalendar.aspx", "MyCalendar.aspx");
                menulist = menulist.Replace("../Help/", "Help/");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/Dashboard_LegalWorkingHours.png'>", "<img class='icon' src='dist/img/Dashboard_LegalWorkingHours.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/cogs.png'>", "<img class='icon' src='dist/img/cogs.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/org-set.png'>", "<img class='icon' src='dist/img/org-set.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/dev-man.png'>", "<img class='icon' src='dist/img/dev-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/emp-man.png'>", "<img class='icon' src='dist/img/emp-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/sit-man.png'>", "<img class='icon' src='dist/img/sit-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/lep-man.png'>", "<img class='icon' src='dist/img/lep-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/mte.png'>", "<img class='icon' src='dist/img/mte.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/pri-man.png'>", "<img class='icon' src='dist/img/pri-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/hol-man.png'>", "<img class='icon' src='dist/img/hol-man.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/rep.png'>", "<img class='icon' src='dist/img/rep.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/ouf.png'>", "<img class='icon' src='dist/img/ouf.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/overtime.png'>", "<img class='icon' src='dist/img/overtime.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/OnDuty.png'>", "<img class='icon' src='dist/img/OnDuty.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/export.png'>", "<img class='icon' src='dist/img/export.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/payroll.png'>", "<img class='icon' src='../dist/img/payroll.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/EMail.png'>", "<img class='icon' src='dist/img/EMail.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/Dashboard.png'>", "<img class='icon' src='dist/img/Dashboard.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/MyCalendar.png'>", "<img class='icon' src='dist/img/MyCalendar.png'>");
                menulist = menulist.Replace("<img class='icon' src='../dist/img/help.png'>", "<img class='icon' src='dist/img/help.png'>");

            }
            if (url == "Configuration")
            {
                menulist = menulist.Replace("<li id='Menu_Configuration'>", "<li class='treeview active' id='Menu_Configuration'>");
            }
            else if (url == "OrgSettings")
            {
                menulist = menulist.Replace("<li id='Organization_Settings'>", "<li class='treeview active' id='Organization_Settings'>");
            }
            else if (url == "Device")
            {
                menulist = menulist.Replace("<li id='Device_Management'>", "<li class='treeview active' id='Device_Management'>");
            }
            else if (url == "EmployeeMaster")
            {
                menulist = menulist.Replace("<li id='Employee_Management'>", "<li class='treeview active' id='Employee_Management'>");
                menulist = menulist.Replace("<li id='Menu_EMp_Master'>", "<li class='treeview active' id='Menu_EMp_Master'>");
            }
            else if (url == "EmployeeReports")
            {
                menulist = menulist.Replace("<li id='Employee_Management'>", "<li class='treeview active' id='Employee_Management'>");
                menulist = menulist.Replace("<li id='Menu_EMp_Report'>", "<li class='treeview active' id='Menu_EMp_Report'>");
            }
            else if (url == "ShiftMaster")
            {
                menulist = menulist.Replace("<li id='Shift_Management'>", "<li class='treeview active' id='Shift_Management'>");
                menulist = menulist.Replace("<li id='Menu_Shift_Master'>", "<li class='treeview active' id='Menu_Shift_Master'>");
            }
            else if (url == "ShiftTransaction")
            {
                menulist = menulist.Replace("<li id='Shift_Management'>", "<li class='treeview active' id='Shift_Management'>");
                menulist = menulist.Replace("<li id='Menu_Shift_Transaction'>", "<li class='treeview active' id='Menu_Shift_Transaction'>");
            }
            else if (url == "ShiftReports")
            {
                menulist = menulist.Replace("<li id='Shift_Management'>", "<li class='treeview active' id='Shift_Management'>");
                menulist = menulist.Replace("<li id='Menu_Shift_Reports'>", "<li class='treeview active' id='Menu_Shift_Reports'>");
            }
            else if (url == "OverTime")
            {
                menulist = menulist.Replace("<li id='Menu_OTCOMPOff'>", "<li class='treeview active' id='Menu_OTCOMPOff'>");
            }
            else if (url == "Terminal")
            {
                menulist = menulist.Replace("<li id='Device_Management'>", "<li class='treeview active' id='Device_Management'>");
                menulist = menulist.Replace("<li id='Master_Terminal'>", "<li class='treeview active' id='Master_Terminal'>");
            }
            else if (url == "LeaveMasters")
            {
                menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                menulist = menulist.Replace("<li id='Menu_Leave_Master'>", "<li class='treeview active' id='Menu_Leave_Master'>");
            }
            else if(url=="PayrollMaster")
            {
                menulist = menulist.Replace("<li id='Master_payrollManagement'>", "<li class='treeview active' id='Master_payrollManagement'>");
                menulist = menulist.Replace("<li id='Menu_TaxMaster'>", "<li class='treeview active' id='Menu_TaxMaster'>");
              
            }
            else if (url == "Payroll Report")
            {
                menulist = menulist.Replace("<li id='Master_payrollManagement'>", "<li class='treeview active' id='Master_payrollManagement'>");
                menulist = menulist.Replace("<li id='Menu_Payroll_Report'>", "<li class='treeview active' id='Menu_Payroll_Report'>");
            }
            else if (url == "LeaveReports")
            {
                menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                menulist = menulist.Replace("<li id='Menu_Leave_Reports'>", "<li class='treeview active' id='Menu_Leave_Reports'>");
            }
            else if (url == "LeaveTransaction")
            {
                menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                menulist = menulist.Replace("<li id='Menu_Leave_Transaction'>", "<li class='treeview active' id='Menu_Leave_Transaction'>");
            }
            else if (url == "LeaveSettings")
            {
                menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                menulist = menulist.Replace("<li id='Org_LeaveSettings'>", "<li class='treeview active' id='Org_LeaveSettings'>");
            }
            else if (url == "PermissionTransaction")
            {
                menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                menulist = menulist.Replace("<li id='Menu_Permission_Transaction'>", "<li class='treeview active' id='Menu_Permission_Transaction'>");
            }
            else if (url == "PermissionReports")
            {
                menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                menulist = menulist.Replace("<li id='Report_Permission'>", "<li class='treeview active' id='Report_Permission'>");
            }
            else if (url == "Approvals")
            {
                menulist = menulist.Replace("<li id='Leave_Permission_Management'>", "<li class='treeview active' id='Leave_Permission_Management'>");
                menulist = menulist.Replace("<li id='Transaction_Approvals'>", "<li class='treeview active' id='Transaction_Approvals'>");
            }
            else if (url == "OnDuty")
            {
                menulist = menulist.Replace("<li id='Menu_OnDuty'>", "<li class='treeview active' id='Menu_OnDuty'>");
            }
            else if (url == "ManualTransaction")
            {
                menulist = menulist.Replace("<li id='ManualTimeEntry'>", "<li class='treeview active' id='ManualTimeEntry'>");
                menulist = menulist.Replace("<li id='Menu_ME_Transaction'>", "<li class='treeview active' id='Menu_ME_Transaction'>");
            }
            else if (url == "ManualReports")
            {
                menulist = menulist.Replace("<li id='ManualTimeEntry'>", "<li class='treeview active' id='ManualTimeEntry'>");
                menulist = menulist.Replace("<li id='Menu_ME_Reports'>", "<li class='treeview active' id='Menu_ME_Reports'>");
            }
            else if (url == "ExportTran")
            {
                menulist = menulist.Replace("<li id='Menu_ExportData'>", "<li class='treeview active' id='Menu_ExportData'>");
                menulist = menulist.Replace("<li id='Menu_ED_Transaction'>", "<li class='treeview active' id='Menu_ED_Transaction'>");
            }
            else if (url == "ExportReport")
            {
                menulist = menulist.Replace("<li id='Menu_ExportData'>", "<li class='treeview active' id='Menu_ExportData   '>");
                menulist = menulist.Replace("<li id='Menu_ED_Reports'>", "<li class='treeview active' id='Menu_ED_Reports'>");
            }
            else if (url == "Attendance Reports")
            {
                menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                menulist = menulist.Replace("<li id='Menu_Report_Attendace'>", "<li class='active' id='Menu_Report_Attendace'>");
               
            }
            else if(url=="Contractor Report")
            {
                menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                menulist = menulist.Replace("<li id='Menu_Report_Attendace'>", "<li class='treeview active' id='Menu_Report_Attendace'>");
               

            }
            else if (url == "Shiftwise Report")
            {
                menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                menulist = menulist.Replace("<li id='Menu_Report_Attendace'>", "<li class='treeview active' id='Menu_Report_Attendace'>");
               

            }
            else if (url == "Exception Reports")
            {
                menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                menulist = menulist.Replace("<li id='Menu_Reports_Entries'>", "<li class='active' id='Menu_Reports_Entries'>");
            }
            else if (url == "Shift")
            {
                menulist = menulist.Replace("<li id='Menu_Reports'>", "<li class='treeview active' id='Menu_Reports'>");
                menulist = menulist.Replace("<li id='Menu_Reports_Shifts'>", "<li class='active' id='Menu_Reports_Shifts'>");
            }
            else if (url == "Others")
            {
                menulist = menulist.Replace("<li id='Other_useful_features'>", "<li class='treeview active' id='Other_useful_features'>");
            }
            
            else if (url == "LicenseManager")
            {
                menulist = menulist.Replace("<li id='System_LicenseManager'>", "<li class='treeview active' id='System_LicenseManager'>");
                menulist = menulist.Replace("<li id='Other_useful_features'>", "<li class='treeview active' id='Other_useful_features'>");
            }
            else if (url == "Transportation")
            {
                menulist = menulist.Replace("<li id='Master_Transportation'>", "<li class='treeview active' id='Master_Transportation'>");
                menulist = menulist.Replace("<li id='Other_useful_features'>", "<li class='treeview active' id='Other_useful_features'>");
            }
            else if (url == "Previlege")
            {
                menulist = menulist.Replace("<li id='Privilege_Management'>", "<li class='treeview active' id='Privilege_Management'>");
            }
            else
            {
                //.....
            }
            HttpContext.Current.Session["TopMenu"] = menulist;
        }
        //This line added by karthikeyan for the user image display perpose
        if (url == "Dashboard" || url == "MyCalendar")
        {
            HttpContext.Current.Session["UserImageURL"] = "LoginImage/" + HttpContext.Current.Session["UserImage"];
        }
        else
        {
            HttpContext.Current.Session["UserImageURL"] = "../LoginImage/" + HttpContext.Current.Session["UserImage"];
        }
    }
    public DataSet GetNotification(Int32 EmployeeID, string UserGroupName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_GetnotificationDetails", new object[] { EmployeeID, UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }

    public DataSet GetPassportExpiryAlert(Int32 EmployeeID, string UserGroupName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_GetPassportExpiryAlert", new object[] { EmployeeID, UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    // Authenticate UserName
    public DataSet UserAuthenticate(string username, string password)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_UserLogin", new object[] { username, password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Select Name of the Authenticated User
    public DataSet SelectUserName(string username, string password)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_SelectUserName", new object[] { username, password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public int CheckPassword(string UserName, string Password)
    {
        int Count = 0;
        try
        {
            Count = (int)db.ExecuteScalar("Proc_TA_CheckPassword", new object[] { UserName, Password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    public void UpdatePassword(string UserName, string Password)
    {
        try
        {
            ds_changePassword = db.ExecuteDataSet("Proc_TA_UpdatePassword", new object[] { UserName, Password });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void GetParentLevels_FromLevelID(int LevelID)
    {
        DbCommand cmd_ParentLevels = db.GetStoredProcCommand("Proc_editLevel", new object[] { LevelID });
        try
        {
            db.ExecuteNonQuery(cmd_ParentLevels);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet GetOrgLevel_FromLevelID(int LevelID)
    {
        DataSet ds_Level = new DataSet();
        try
        {
            ds_Level = db.ExecuteDataSet("Proc_TA_GetLevelName_FromLevelID", new object[] { LevelID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Level;
    }
    public DataSet GetParentLevels()
    {
        DataSet ds_ParentLevels = new DataSet();
        try
        {
            ds_ParentLevels = db.ExecuteDataSet("Proc_TA_ParentIDs", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ParentLevels;
    }
    //select Year setting details
    public DataSet GetYearsetting()
    {
        DataSet ds_Yearsetting = new DataSet();
        try
        {
            ds_Yearsetting = db.ExecuteDataSet("Proc_TA_SelectYearSetting", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Yearsetting;
    }
    public DataSet GetNextYearsetting()
    {
        DataSet dsNextYearsetting = new DataSet();
        try
        {
            dsNextYearsetting = db.ExecuteDataSet("Proc_TA_SelectNextYearSetting", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsNextYearsetting;
    }
    public DataSet GetSuccessiveYearsetting()
    {
        DataSet ds_Yearsetting = new DataSet();
        try
        {
            ds_Yearsetting = db.ExecuteDataSet("Proc_TA_SuccessiveYearSettings", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Yearsetting;
    }
    public DataSet getNewsBanner(string position)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_getNews", new object[] { position });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet getNewsByID(int NewsID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_getNewsById", new object[] { NewsID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Login for admin
    public int AdminUserAuthenticate(string username, string password)
    {
        DataSet ds = new DataSet();
        int count = 0;
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_AdminLogin", new object[] { username, password });
            count = Convert.ToInt32(ds.Tables[0].Rows[0]["UID"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        ds.Dispose();
        return count;
    }
    public DataSet getUserMenu(int parentId, int groupId, string strType)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_GetUserMenu", new object[] { parentId, groupId, strType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet getReportMenu(string ReportsMenu, int GroupId)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_ReportsSubMenu", new object[] { ReportsMenu, GroupId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet getReportMenu(string ReportsMenu, int GroupId, string strType)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_ReportsSubMenuForExpress", new object[] { ReportsMenu, GroupId, strType });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet getmastersSubMenu(int ReportsMenu)
    {
        DataSet dsMnu = new DataSet();
        try
        {
            dsMnu = db.ExecuteDataSet("Proc_TA_getmastersSubMenu", new object[] { ReportsMenu });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsMnu;
    }
    public DataSet CheckUserStatus()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_CheckUserStatus", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void UpdateUserStatus(string UserId, string IpAddress, DateTime LoginTime, bool Status, string SessionId)
    {
        try
        {
            DbCommand cmd_UpdateUserStatus = db.GetStoredProcCommand("Proc_TA_UpdateUserStatus", new object[] { UserId, IpAddress, LoginTime, Status, SessionId });
            cmd_UpdateUserStatus.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_UpdateUserStatus);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void UpdateExistingUserStatusFalse(string UserId)
    {
        try
        {
            DbCommand cmd_UpdateExistingUserStatusFalse = db.GetStoredProcCommand("Proc_TA_UpdateExistingUserStatusFalse", new object[] { UserId });
            cmd_UpdateExistingUserStatusFalse.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_UpdateExistingUserStatusFalse);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update user status as false when logout
    public void UpdateExistingUserStatusFalse(string UserId, string Ipaddress, string SessionId)
    {
        try
        {
            DbCommand cmd_UpdateExistingUserStatusFalse = db.GetStoredProcCommand("Proc_TA_UpdateConcurrentUser", new object[] { UserId, Ipaddress, SessionId });
            cmd_UpdateExistingUserStatusFalse.CommandTimeout = 0;
            int i = db.ExecuteNonQuery(cmd_UpdateExistingUserStatusFalse);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// Checks the concurrent user count.
    /// </summary>
    public int CheckConcurrentUserCount()
    {
        int concurrentUserCount = 0;
        try
        {
            DbCommand cmd_CheckConcurrentUserCount = db.GetStoredProcCommand("Proc_TA_CheckConcurrentUserCount");
            cmd_CheckConcurrentUserCount.CommandTimeout = 0;
            concurrentUserCount = Convert.ToInt32(db.ExecuteScalar(cmd_CheckConcurrentUserCount));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return concurrentUserCount;
    }
    /// <summary>
    /// Logouts the user.
    /// </summary>
    public void LogoutUser(string UserId, string Ipaddress, string SessionId)
    {
        try
        {
            DbCommand cmd_LogoutUser = db.GetStoredProcCommand("Proc_TA_LogoutUserOwn", new object[] { UserId, Ipaddress, SessionId });
            cmd_LogoutUser.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_LogoutUser);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void LogoutAdmin(string UserId)
    {
        try
        {
            DbCommand cmd_LogoutAdmin = db.GetStoredProcCommand("Proc_TA_LogoutAdmin", new object[] { UserId });
            cmd_LogoutAdmin.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_LogoutAdmin);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// Checking for special rights
    /// </summary>
    /// <param name="GroupID"></param>
    /// <returns></returns>
    public DataSet SelectGroupName(int GroupID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_Select_UserGroupName", new object[] { GroupID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public cls_Common()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString == string.Empty)
        {
        }
        else
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db.DbProviderFactory;
        db = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    //Converts the Date from any Date Format to MM/DD/YYYY
    public string DateConvertion(string Format, string strDateTime)
    {
        if (strDateTime == "")
        {
            return "";
        }
        // Getting Month
        int indexMonth = -2;
        int intMonthNoOfChars = 0;
        string strMonth = "";
        int indexMMM = Format.IndexOf(@"MMM");
        if (indexMMM == -1)
        {
            int indexMM = Format.IndexOf(@"MM");
            if (indexMM >= 0)
            {
                indexMonth = indexMM;
                intMonthNoOfChars = 2;
            }
        }
        else
        {
            indexMonth = indexMMM;
            intMonthNoOfChars = 3;
        }
        if (indexMonth != -2)
        {
            strMonth = strDateTime.Substring(indexMonth, intMonthNoOfChars);
        }
        // Getting Date
        int indexDate = -2;
        int intDateNoOfChars = 0;
        string strDate = "";
        int indexDD = Format.IndexOf(@"dd");
        if (indexDD >= 0)
        {
            indexDate = indexDD;
            intDateNoOfChars = 2;
        }
        if (indexDate != -2)
        {
            strDate = strDateTime.Substring(indexDate, intDateNoOfChars);
        }
        // Getting Year
        int indexYear = -2;
        int intYearNoOfChars = 0;
        string strYear = "";
        int indexYYYY = Format.IndexOf(@"yyyy");
        if (indexYYYY == -1)
        {
            int indexYY = Format.IndexOf(@"yy");
            if (indexYY >= 0)
            {
                indexYear = indexYY;
                intYearNoOfChars = 2;
            }
        }
        else
        {
            indexYear = indexYYYY;
            intYearNoOfChars = 4;
        }
        if (indexYear != -2)
        {
            strYear = strDateTime.Substring(indexYear, intYearNoOfChars);
        }
        string strFinalDate = "";
        if (indexMMM >= 0)
        {
            strFinalDate = strDate + "/" + strMonth + "/" + strYear;
        }
        else
        {
            // strFinalDate = strMonth + "/" + strDate + "/" + strYear;
            strFinalDate = strYear + "/" + strMonth + "/" + strDate;
        }
        DateTime dtmFinalDate = new DateTime();
        try
        {
            dtmFinalDate = DateTime.Parse(strFinalDate);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return (strFinalDate);
    }
    public string DateTimeConvertion(string Format, string strDateTime, string FormatType)
    {
        if (strDateTime == "")
        {
            return "";
        }
        // Getting Month
        int indexMonth = -2;
        int intMonthNoOfChars = 0;
        string strMonth = "";
        int indexMMM = Format.IndexOf(@"MMM");
        if (indexMMM == -1)
        {
            int indexMM = Format.IndexOf(@"MM");
            if (indexMM >= 0)
            {
                indexMonth = indexMM;
                intMonthNoOfChars = 2;
            }
        }
        else
        {
            indexMonth = indexMMM;
            intMonthNoOfChars = 3;
        }
        if (indexMonth != -2)
        {
            strMonth = strDateTime.Substring(indexMonth, intMonthNoOfChars);
        }
        // Getting Date
        int indexDate = -2;
        int intDateNoOfChars = 0;
        string strDate = "";
        int indexDD = Format.IndexOf(@"dd");
        if (indexDD >= 0)
        {
            indexDate = indexDD;
            intDateNoOfChars = 2;
        }
        if (indexDate != -2)
        {
            strDate = strDateTime.Substring(indexDate, intDateNoOfChars);
        }
        // Getting Year
        int indexYear = -2;
        int intYearNoOfChars = 0;
        string strYear = "";
        int indexYYYY = Format.IndexOf(@"yyyy");
        if (indexYYYY == -1)
        {
            int indexYY = Format.IndexOf(@"yy");
            if (indexYY >= 0)
            {
                indexYear = indexYY;
                intYearNoOfChars = 2;
            }
        }
        else
        {
            indexYear = indexYYYY;
            intYearNoOfChars = 4;
        }
        if (indexYear != -2)
        {
            strYear = strDateTime.Substring(indexYear, intYearNoOfChars);
        }
        string strFinalDate = "";
        if (indexMMM >= 0)
        {
            strFinalDate = strDate + "/" + strMonth + "/" + strYear;
        }
        else
        {
            strFinalDate = strMonth + "/" + strDate + "/" + strYear;
        }
        DateTime dtmFinalDate = new DateTime();
        try
        {
            dtmFinalDate = DateTime.Parse(strFinalDate);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        // Getting Hours
        int indexHours = -2;
        int inHourstNoOfChars = 0;
        string strHours = "00";
        int indexhh = Format.IndexOf(@"hh");
        if (indexhh >= 0)
        {
            indexHours = indexhh;
            inHourstNoOfChars = 2;
        }
        else
        {
            int indexHH = Format.IndexOf(@"HH");
            if (indexHH >= 0)
            {
                indexHours = indexHH;
                inHourstNoOfChars = 2;
            }
        }
        if (indexHours != -2)
        {
            strHours = strDateTime.Substring(indexHours, inHourstNoOfChars);
        }
        // Getting Minutes
        int indexMins = -2;
        int intMinsNoOfChars = 0;
        string strMins = "00";
        int indexmm = Format.IndexOf(@"mm");
        if (indexmm >= 0)
        {
            indexMins = indexmm;
            intMinsNoOfChars = 2;
        }
        if (indexMins != -2)
        {
            strMins = strDateTime.Substring(indexMins, intMinsNoOfChars);
        }
        // Getting Seconds
        int indexSecs = -2;
        int intSecsNoOfChars = 0;
        string strSeconds = "00";
        int indexss = Format.IndexOf(@"ss");
        if (indexss >= 0)
        {
            indexSecs = indexss;
            intSecsNoOfChars = 2;
        }
        if (indexSecs != -2)
        {
            strSeconds = strDateTime.Substring(indexSecs, intSecsNoOfChars);
        }
        // Getting AM or PM - If 12 Hours Format
        int indexAMPM = -2;
        int intAMPMNoOfChars = 0;
        string strAMPM = "";
        int indextt = Format.IndexOf(@"tt");
        if (indextt >= 0)
        {
            indexAMPM = indextt;
            intAMPMNoOfChars = 2;
        }
        if (indexAMPM != -2)
        {
            strAMPM = strDateTime.Substring(indexAMPM, intAMPMNoOfChars);
        }
        string strTime = "";
        if (indextt >= 0)
        {
            strTime = strHours + ":" + strMins + ":" + strSeconds + " " + strAMPM;
        }
        else
        {
            strTime = strHours + ":" + strMins + ":" + strSeconds;
        }
        DateTime dtmFinalTime = new DateTime();
        try
        {
            dtmFinalTime = DateTime.Parse(strTime);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        if (FormatType == "D")
        {
            return strFinalDate;
        }
        else if (FormatType == "T")
        {
            return strTime;
        }
        else if (FormatType == "B")
        {
            return (strFinalDate + " " + strTime);
        }
        else
        {
            return "";
        }
    }
    //selects the whole text of the control
    public string SelectAll(Control ctrl)
    {
        string selectScript = "<script language='javascript'>" + "document.getElementById('" + ctrl.ClientID + "').select();</script>";
        return selectScript;
    }
    public string KeepAlive()
    {
        int int_MilliSecondsTimeOut = (HttpContext.Current.Session.Timeout * 60000) - 30000;
        StringBuilder sScript = new StringBuilder();
        sScript.Append("<script type='text/javascript'>");
        //Number Of Reconnects   
        sScript.Append("var count=0;");
        //Maximum reconnects Setting   
        sScript.Append("var max = 6;");
        sScript.Append("function Reconnect(){");
        sScript.Append("count++;");
        sScript.Append("var d = new Date();");
        sScript.Append("var curr_hour = d.getHours();");
        sScript.Append("var curr_min = d.getMinutes();");
        sScript.Append("if (count < max){");
        sScript.Append("window.status = 'Refreshed ' + count.toString() + ' time(s) [' + curr_hour + ':' + curr_min + ']';");
        sScript.Append("var img = new Image(1,1);");
        sScript.Append("img.src = 'reconnect.aspx';");
        sScript.Append("}");
        sScript.Append("}");
        sScript.Append("window.setInterval('Reconnect()',");
        sScript.Append(int_MilliSecondsTimeOut.ToString() + ");");
        sScript.Append("</script>");
        return sScript.ToString();
    }
    //-- class for mandatory pages
    public DataSet GetRowsCountAllTables()
    {
        DataSet ds = new DataSet();
        string strScript = "Proc_TA_GetRowsCountAllPage";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_GetRowsCountAllPageStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_GetRowsCountAllPageStandard";
            }
        }
        ds = db.ExecuteDataSet(strScript);
        return ds;
    }
    public void UpdateRowsCountAllTables()
    {
        string strScript = "Proc_TA_UpdateRowsCount";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_UpdateRowsCountStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_UpdateRowsCountStandard";
            }
        }
        db.ExecuteNonQuery(strScript);
    }
    public DataSet GetRowsCountInTable(int PageID)
    {
        DataSet ds = new DataSet();
        string strScript = "Proc_TA_GetRowsCountInPage";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_GetRowsCountInPageStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_GetRowsCountInPageStandard";
            }
        }
        ds = db.ExecuteDataSet(strScript, new object[] { PageID });
        return ds;
    }
    public DataSet GetCheckMandatory()
    {
        DataSet ds = new DataSet();
        string strScript = "Proc_TA_CheckMandatoryPage";
        if (HttpContext.Current.Session["Edition"] != null)
        {
            if (HttpContext.Current.Session["Edition"].ToString() == "1")
            {
                strScript = "Proc_TA_CheckMandatoryPageStandard";
            }
        }
        if (HttpContext.Current.Session["Demo"] != null)
        {
            if (HttpContext.Current.Session["Demo"].ToString() == "Standard" || HttpContext.Current.Session["Demo"].ToString() == "Express")
            {
                strScript = "Proc_TA_CheckMandatoryPageStandard";
            }
        }
        ds = db.ExecuteDataSet(strScript);
        return ds;
    }
    //--end for class for  mandatory pages
    public string CheckDatabaseExists(string conString)
    {
        return objDataAccess.CheckDatabaseExists(conString);
    }
    public int CheckSuperAdminUser(string conString, string UserName, string strPassword)
    {
        SqlConnection sqlCon;
        string connStr = conString;
        //Encrypt the password
        strPassword = PasswordEncryption(strPassword);
        int intSuperAdminUser = 0;
        // Create new connection to database
        sqlCon = new SqlConnection(connStr);
        string strCmd = "Proc_TA_CheckSuperAdminUser";
        try
        {
            //Open Connection
            sqlCon.Open();
            SqlCommand cmd = new SqlCommand();
            SqlParameter pUserName = new SqlParameter("@Username", UserName);
            SqlParameter pPassWord = new SqlParameter("@PassWord", strPassword);
            SqlParameter[] pParams = { pUserName, pPassWord };
            cmd.Connection = sqlCon;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.CommandText = strCmd;
            cmd.Parameters.AddRange(pParams);
            cmd.CommandTimeout = 0;
            intSuperAdminUser = Convert.ToInt32(cmd.ExecuteScalar());
            cmd.Parameters.Clear();
        }
        catch (Exception ex)
        {
            throw ex;
        }
        finally
        {
            //Close Connection
            sqlCon.Close();
        }
        return intSuperAdminUser;
    }
    // Encoding Password
    public string PasswordEncryption(string EPassword)
    {
        MD5 md5 = MD5.Create();
        byte[] inputBytes, hashBytes;
        inputBytes = Encoding.ASCII.GetBytes(EPassword);
        hashBytes = md5.ComputeHash(inputBytes);
        EPassword = Convert.ToBase64String(hashBytes);
        return EPassword;
    }
    public DataSet getEmployeeAutoId(string EmployeeCodeId)
    {
        DataSet dsEmp = new DataSet();
        try
        {
            dsEmp = db.ExecuteDataSet("Proc_TA_GetEmployeeAutoId", new object[] { EmployeeCodeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmp;
    }
    public int CheckPageExistsInLicense(int pageID)
    {
        int Status = 0;
        try
        {
            Status = (int)db.ExecuteScalar("Proc_TA_CheckPageExistsInLicense", new object[] { pageID });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return Status;
    }
    public DataTable GetErrorVersionDetails(string PageName, string TrackingPlatform, string ErrorMsg, string ErrorText)
    {
        DataSet dsEmp = new DataSet();
        try
        {
            dsEmp = db.ExecuteDataSet("Proc_TA_GetErrorVersionDetails", new object[] { PageName, TrackingPlatform, ErrorMsg, ErrorText });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmp.Tables.Count > 0 ? dsEmp.Tables[0] : new DataTable();
    }
    //Get the Current Month Start day in all reports
    public DateTime CurrentMonthStartDate()
    {
        DateTime CurrentDate;
        //int StartDate;
        CurrentDate = (DateTime.Now);
        //StartDate = (DateTime.Now.AddDays(-1).Day);
        CurrentDate = CurrentDate.AddDays(-(CurrentDate.AddDays(-1).Day));
        return CurrentDate;
    }
    public DataTable GetParentLevelIdsForEmailScheduler(int EmailLevelid)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_Ta_GetParentLevelIdsForEmailScheduler", new object[] { EmailLevelid });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds.Tables[0];
    }
    //select Year setting details
    public DataSet GetYearsettingForLeaveReport()
    {
        DataSet ds_Yearsetting = new DataSet();
        try
        {
            ds_Yearsetting = db.ExecuteDataSet("Proc_TA_SelectYearSettingForLeaveReport", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Yearsetting;
    }
    //select next Year setting details
    /// <summary>
    /// Added by MAnjula.P on 17-Apr-2014 from ANGLER 
    /// </summary>
    /// <returns></returns>
    public DataSet GetNextYearsetting_Angler()
    {
        DataSet dsNextYearsetting = new DataSet();
        try
        {
            dsNextYearsetting = db.ExecuteDataSet("Proc_TA_SelectNextYearSetting", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsNextYearsetting;
    }
    public string[] commaStringToArray(string strComma)
    {
        string[] strArray;
        strArray = strComma.Split(new char[] { ',' });
        string[] intArray = new string[strArray.Length];
        for (int i = 0; i < strArray.Length; i++)
            intArray[i] = Convert.ToString(strArray[i]);
        return intArray;
    }
    // Authenticate UserName Domain
    public DataSet UserAuthenticateDomain(string DomainUserName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_DomainLogin", new object[] { DomainUserName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }

    public string SendMail(MailMessage mailMessage)
    {
        try
        {
            string strSMTPPort = ConfigurationManager.AppSettings.Get("SMTPPort");
            SmtpClient loSMTPServer = new SmtpClient(strSMTPPort, Convert.ToInt32(strSMTPPort));
            loSMTPServer.Host = ConfigurationManager.AppSettings.Get("SMTPClientHost");
            string strHost = ConfigurationManager.AppSettings.Get("SMTPClientHost");
            string strSSLEnable = ConfigurationManager.AppSettings.Get("SSLEnable");
            string strMailAuthentication = ConfigurationManager.AppSettings.Get("MailAuthentication");
            string strMailAuthenticateUser = ConfigurationManager.AppSettings.Get("MailAuthenticateUser");
            string strMailAuthenticatePassword = ConfigurationManager.AppSettings.Get("MailAuthenticatePassword");
            if (strMailAuthentication == "1")
            {
                strMailAuthenticatePassword = Cryptographys.Cryptography.Decrypt(strMailAuthenticatePassword, "TimecheckPhaseI");
            }
            loSMTPServer.Port = Convert.ToInt32(strSMTPPort);
            if (strSSLEnable == "1")
            {
                loSMTPServer.EnableSsl = true;

            }
            else
            {
                loSMTPServer.EnableSsl = false;
            }
            if (strMailAuthentication == "0")
            {
                loSMTPServer.UseDefaultCredentials = true;
            }
            else
            {
                loSMTPServer.UseDefaultCredentials = false;
            }
            mailMessage.IsBodyHtml = true;
            if (strMailAuthentication == "1")
            {
                System.Net.ServicePointManager.ServerCertificateValidationCallback = delegate (object s,
             System.Security.Cryptography.X509Certificates.X509Certificate certificate,
             System.Security.Cryptography.X509Certificates.X509Chain chain,
             System.Net.Security.SslPolicyErrors sslPolicyErrors)
                {
                    return true;
                };
                loSMTPServer.Credentials = new System.Net.NetworkCredential(strMailAuthenticateUser, strMailAuthenticatePassword);
                loSMTPServer.Send(mailMessage);

                return "UnSuccess";
            }
            else
            {
                loSMTPServer.DeliveryMethod = SmtpDeliveryMethod.Network;
                loSMTPServer.Send(mailMessage);

                return "Success";
            }
        }
        catch (Exception Ex)
        {

            throw;
        }

    }

    //public void SendMail(MailMessage mailMessage)
    //{
    //    try
    //    {
    //        string strSMTPPort = ConfigurationManager.AppSettings.Get("SMTPPort");
    //        SmtpClient loSMTPServer = new SmtpClient(strSMTPPort, Convert.ToInt32(strSMTPPort));
    //        loSMTPServer.Host = ConfigurationManager.AppSettings.Get("SMTPClientHost");
    //        string strHost = ConfigurationManager.AppSettings.Get("SMTPClientHost");
    //        string strSSLEnable = ConfigurationManager.AppSettings.Get("SSLEnable");
    //        string strMailAuthentication = ConfigurationManager.AppSettings.Get("MailAuthentication");
    //        string strMailAuthenticateUser = ConfigurationManager.AppSettings.Get("MailAuthenticateUser");
    //        string strMailAuthenticatePassword = ConfigurationManager.AppSettings.Get("MailAuthenticatePassword");
    //        if (strMailAuthentication == "1")
    //        {
    //            strMailAuthenticatePassword = Cryptographys.Cryptography.Decrypt(strMailAuthenticatePassword, "TimecheckPhaseI");
    //        }
    //        loSMTPServer.Port = Convert.ToInt32(strSMTPPort);
    //        if (strSSLEnable == "1")
    //        {
    //            loSMTPServer.EnableSsl = true;
    //        }
    //        else
    //        {
    //            loSMTPServer.EnableSsl = false;
    //        }
    //        if (strMailAuthentication == "0")
    //        {
    //            loSMTPServer.UseDefaultCredentials = true;
    //        }
    //        else
    //        {
    //            loSMTPServer.UseDefaultCredentials = false;
    //        }
    //        mailMessage.IsBodyHtml = true;
    //        if (strMailAuthentication == "1")
    //        {
    //            System.Net.ServicePointManager.ServerCertificateValidationCallback = delegate (object s,
    //         System.Security.Cryptography.X509Certificates.X509Certificate certificate,
    //         System.Security.Cryptography.X509Certificates.X509Chain chain,
    //         System.Net.Security.SslPolicyErrors sslPolicyErrors)
    //            {
    //                return true;
    //            };
    //            loSMTPServer.Credentials = new System.Net.NetworkCredential(strMailAuthenticateUser, strMailAuthenticatePassword);
    //            loSMTPServer.Send(mailMessage);
    //        }
    //        else
    //        {
    //            loSMTPServer.DeliveryMethod = SmtpDeliveryMethod.Network;
    //            loSMTPServer.Send(mailMessage);
    //        }
    //    }
    //    catch (Exception Ex)
    //    {

    //        throw;
    //    }

    //}
    public DataSet GetHelpContent()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_GetHelpContent", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet GetPassportVisaExpiryDetails(Int32 EmployeeID, string UserGroupName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_GetPassportVisaExpiryDetailsEmployee", new object[] { EmployeeID, UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
}
