using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
/// <summary>
/// Summary description for ShiftExchange
/// </summary>
/// 
public class ShiftExchange
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    public void Delete_EmployeeDetails()
    {
        try
        {
            objDataAccess.ExecuteNonQuery("Proc_TA_DeleteTempShiftAllocation");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public string GetEmployeeCode()
    {
        DataSet ds_EmpCode = new DataSet();
        string EmployeeCode = string.Empty;
        try
        {
            ds_EmpCode = objDataAccess.ExecuteDataSet("Proc_Ta_GetEmployeeDetailFromTempShiftAllocation");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        if (ds_EmpCode.Tables[0].Rows.Count > 0)
        {
            EmployeeCode = Convert.ToString(ds_EmpCode.Tables[0].Rows[0][0]);
        }
        return EmployeeCode;
    }
    public void ResetPassword(string EmpId, string Password)
    {
        try
        {
            htable.Clear();
            htable.Add("@EmpId", EmpId);
            htable.Add("@Password", Password);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_ResetPassword");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet Select_DateandTimeFormat()
    {
        DataSet ds_DateTime = new DataSet();
        try
        {
            ds_DateTime = objDataAccess.ExecuteDataSet("Proc_TA_DateandTimeFormat");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_DateTime;
    }
    public void InsertorUpdate_DateandTimeFormat(string DateFormat, string TimeFormat, int EmpId, int isdomain, string DomainName, string DomainadminUserName, string DomainadminPassword)
    {
        try
        {
            htable.Clear();
            htable.Add("@DateFormat", DateFormat);
            htable.Add("@TimeFormat", TimeFormat);
            htable.Add("@isDomain", isdomain);
            htable.Add("@DomainName", DomainName);
            htable.Add("@DomainAdminUserName", DomainadminUserName);
            htable.Add("@DomainAdminPassword", DomainadminPassword);
            htable.Add("@EmpId", EmpId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DateandTimeFormatUpdation");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void InsertMailConfiguration(string FromEmailId, string SMTPHost, string SMTPPort, int sslEnabled, int authenticationEnabled, string userName, string password, int isRequired)
    {
        try
        {
            htable.Clear();
            htable.Add("@FromEmailId", FromEmailId);
            htable.Add("@SMTPClientHost", SMTPHost);
            htable.Add("@SMTPPort", SMTPPort);
            htable.Add("@SSLEnable", sslEnabled);
            htable.Add("@MailAuthentication", authenticationEnabled);
            htable.Add("@MailAuthenticateUser", userName);
            htable.Add("@MailAuthenticatePassword", password);
            htable.Add("@isRequired", isRequired);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_InsertMailConfiguration");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
}