﻿using Microsoft.Practices.EnterpriseLibrary.Data;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Linq;
using System.Text;
public class TransferEventData
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    public void InsertTransfer(Int32 Emp_AutoID, string Trnsfr_frm, string Trnsfr_To, string Trnsfr_EtyDteTme, string Trnsfr_Dte, int Etry_RsdBy, int NwDsgtonID, int NwReprtngTo, int NwApprvlAuthrty, string Remarks, string IsImprtd, string Trnsfr_status, string flag)
    {
        try
        {
            DbCommand cmd = DBCon.GetStoredProcCommand("Proc_TA_InsertTransferEmployee", new object[] { Emp_AutoID, Trnsfr_frm, Trnsfr_To, Trnsfr_EtyDteTme, Trnsfr_Dte, Etry_RsdBy, NwDsgtonID, NwReprtngTo, NwApprvlAuthrty, Remarks, IsImprtd, Trnsfr_status, flag });
            cmd.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public TransferEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString == string.Empty)
        {
        }
        else
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public DataSet SelectEmployeeTransferSearch(string empID, string tnsfrfrmDte, string trnsfrToDte, string empName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectEmployeeTransfer", new object[] { empID, tnsfrfrmDte, trnsfrToDte, empName });
        }
        catch (Exception ex)
        {
            throw;
        }
        return ds;
    }
    public int CheckTransferAlreadyExists(Int64 EmployeeCodeId, string Trnsfrdate)
    {
        int Count = 0;
        try
        {
            Count = (int)DBCon.ExecuteScalar("Proc_TA_ChckTrnsfrAlrdyExstsBasedOnEmp_Date", new object[] { EmployeeCodeId, Trnsfrdate });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return Count;
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public void UpdateEmployeeTransfer(string RecID)
    {
        DBCon.ExecuteNonQuery("Proc_TA_UpdateTransferEmployee", new object[] { RecID });
    }
}
