using System;
using System.Security;
using System.Security.Cryptography;
namespace Cryptographys
{
    using System;
    using System.IO;
    using System.Xml;
    using System.Text;
    using System.Security.Cryptography;
    using System.Data.Common;
    using System.Configuration;
    using Npgsql;
    public class Cryptography
    {
        /// <summary>
        ///    Decrypts  a particular string with a specific Key
        /// </summary>
        public static string Decrypt(string stringToDecrypt, string sEncryptionKey)
        {
            byte[] key = { };
            byte[] IV = { 10, 20, 30, 40, 50, 60, 70, 80 };
            byte[] inputByteArray = new byte[stringToDecrypt.Length];
            try
            {
                key = Encoding.UTF8.GetBytes(sEncryptionKey.Substring(0, 8));
                DESCryptoServiceProvider des = new DESCryptoServiceProvider();
                inputByteArray = Convert.FromBase64String(stringToDecrypt);
                MemoryStream ms = new MemoryStream();
                CryptoStream cs = new CryptoStream(ms, des.CreateDecryptor(key, IV), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                Encoding encoding = Encoding.UTF8;
                return encoding.GetString(ms.ToArray());
            }
            catch (System.Exception ex)
            {
                return (string.Empty);
            }
        }
        //Decrypting the Node ID/Activation code
        public static string Decrypt_BioStar(string str, string password)
        {
            string[] full = str.Split(",".ToCharArray());
            str = full[0];
            byte[] buffer;
            buffer = Convert.FromBase64String(str);
            PasswordDeriveBytes pdb = new PasswordDeriveBytes(password, new byte[] { 0x51, 0x76, 0x61, 0x6e, 0x20, 0x4d, 0x65, 0x64, 0x76, 0x65, 0x64, 0x65, 0x76 });
            return Encoding.Unicode.GetString(Decrypt(buffer, pdb.GetBytes(32), pdb.GetBytes(16)));
        }
        //Decrypting using Rijndael algorithm
        private static byte[] Decrypt(byte[] byteArrayToEncrypt, byte[] Key, byte[] IV)
        {
            MemoryStream memoryStream = new MemoryStream();
            Rijndael rijndael = Rijndael.Create();
            rijndael.Key = Key;
            rijndael.IV = IV;
            CryptoStream cryptoStream;
            cryptoStream = new CryptoStream(memoryStream, rijndael.CreateDecryptor(), CryptoStreamMode.Write);
            cryptoStream.Write(byteArrayToEncrypt, 0, byteArrayToEncrypt.Length);
            cryptoStream.Close();
            byte[] returnArray = memoryStream.ToArray();
            memoryStream.Close();
            return returnArray;
        }
        /// <summary>
        ///   Encrypts  a particular string with a specific Key
        /// </summary>
        /// <param name="stringToEncrypt"></param>
        /// <param name="sEncryptionKey"></param>
        /// <returns></returns>
        public static string Encrypt(string stringToEncrypt, string sEncryptionKey)
        {
            byte[] key = { };
            byte[] IV = { 10, 20, 30, 40, 50, 60, 70, 80 };
            byte[] inputByteArray; //Convert.ToByte(stringToEncrypt.Length) 
            try
            {
                key = Encoding.UTF8.GetBytes(sEncryptionKey.Substring(0, 8));
                DESCryptoServiceProvider des = new DESCryptoServiceProvider();
                inputByteArray = Encoding.UTF8.GetBytes(stringToEncrypt);
                MemoryStream ms = new MemoryStream();
                CryptoStream cs = new CryptoStream(ms, des.CreateEncryptor(key, IV), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                return Convert.ToBase64String(ms.ToArray());
            }
            catch (System.Exception ex)
            {
                return (string.Empty);
            }
        }
        public static string GetDecryptedConnectionString()
        {
  
            string strEncryptedString = ConfigurationSettings.AppSettings["ConnectionString"].ToString();
            string strDecryptedString = Cryptographys.Cryptography.Decrypt(strEncryptedString, "TimecheckPhaseI");
            // strDecryptedString = @"Data Source=ANGLER129;Initial Catalog=TimeCheckV1.6_Testing;User ID=sa;Pwd=angler123;";
            //strDecryptedString = @"Data Source=ANGLER54\SQLEXPR2;Initial Catalog=TimeCheckV1.6May;User ID=sa;Pwd=;";
            //strDecryptedString = @"Data Source=WIN-I98O5SR3OVB\SQLEXPRESS;Initial Catalog=Timecheck;User ID=sa;Pwd=Admin@123;";
             //strDecryptedString = @"Server=127.0.0.1;User Id=postgres;Password=admin123;Database=bioadmin;";
            strDecryptedString = @"Data Source=ANGLER97\SQL2014;Initial Catalog=TimecheckV3.2;User ID=sa;Pwd=angler123;";
            return strDecryptedString;
        }
        public static string Decrypt(string str)
        {
            string[] full = str.Split(",".ToCharArray());
            str = full[0];
            byte[] buffer;
            str = str.Replace(" ", "+");
            buffer = Convert.FromBase64String(str);
            PasswordDeriveBytes pdb = new PasswordDeriveBytes("", new byte[] { 0x51, 0x76, 0x61, 0x6e, 0x20, 0x4d, 0x65, 0x64, 0x76, 0x65, 0x64, 0x65, 0x76 });
            return Encoding.Unicode.GetString(Decrypt(buffer, pdb.GetBytes(32), pdb.GetBytes(16)));
        }
    }
}