using System;
using System.IO;
using System.Web;
using System.Configuration;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Globalization;
using System.Data.OleDb;
using System.Runtime.InteropServices;
using System.Text;
using System.ServiceProcess;
public delegate int CallBack(uint nTotal, uint nDone);
public delegate int FuncProcessData(string strDevInfo, uint nStrDevInfoLen, string strRecvInfo, uint nStrRecvInfo);
namespace TimecheckCollectRawData
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [DllImport("HDCP_Utils.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern string HDCP_Base64Decode(string pInputInfo, ref uint pSizeInput);
        [DllImport("HwDevComm.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int HwDev_Execute(string pDevInfoBuf, int nDevInfoLen,
                                               IntPtr pSendBuf, int nSendLen,
                                               ref IntPtr pRecvBuf, ref uint pRecvLen,
                                               CallBack pFuncTotalDone);
        [DllImport("HwDevComm.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int HwDev_Server(int nSwith,
                                              string pServerInfo, int nServerInfoLen,
                                              FuncProcessData pFuncProcessData);
        [DllImport("HwDevComm.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        public static extern int HwDev_Finish(ref IntPtr pRecvBuf);
        [DllImport("kernel32.dll")]
        public static extern IntPtr GlobalAlloc(int uFlags, int dwBytes);
        [DllImport("kernel32.dll")]
        public static extern IntPtr GlobalFree(IntPtr hMem);
        [DllImport("kernel32.dll")]
        public static extern IntPtr GlobalLock(IntPtr hMem);
        [DllImport("kernel32.dll")]
        public static extern bool GlobalUnlock(IntPtr hMem);
        static void Main()
        {
            ServiceBase[] ServicesToRun;
            ServicesToRun = new ServiceBase[] { new TimecheckCollectDataService() };
            ServiceBase.Run(ServicesToRun);
        }
    }
}