﻿using System;
using System.Configuration;
using System.Data;
using System.Globalization;
using System.Net;
using System.Net.Mail;
using System.Resources;
using System.Threading;
using System.Web;


public class Email_Triggering
{
    DataAccessLayer.DataAccess objDAL = new DataAccessLayer.DataAccess();
    ManualEntryEventData obj = new ManualEntryEventData();
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    CultureInfo objCultureInfo;
    ResourceManager rm;
    int isTriggered = 0;
    bool blnCheckEmail = true;
    string subject = "", MailID = "", EmpName = "", emailFrom = "", strSMTPPort = "", strHost = "", strSSLEnable = "", strMailAuthentication = "", strMailAuthenticateUser = "", strMailAuthenticatePassword = "";
    DataTable dtTableScript = new DataTable();
    DataSet ds_EmpName = new DataSet();
    string bodyContentFinal = "";
    public int PassingEmpDetailsAndModuleForEmailTriggering(string frm, string EmpCode)
    {
        string strSourceLanguage;
        strSourceLanguage = Convert.ToString(HttpContext.Current.Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(strSourceLanguage, System.Reflection.Assembly.Load("App_GlobalResources"));
        objCultureInfo = Thread.CurrentThread.CurrentCulture;
        if (frm == "ResetPassword")
        {
            if (EmpCode != null && EmpCode != "")
            {
                ds_EmpName = obj.SelectEmpName(Convert.ToInt32(HttpContext.Current.Session["EmpAutoID"]), EmpCode, Convert.ToString(HttpContext.Current.Session["UserGroupName"]), HttpContext.Current.Session["GradeLevel"].ToString(), "", Convert.ToInt32(HttpContext.Current.Session["parentLevelId"]), "");
                if (ds_EmpName != null)
                {
                    if (ds_EmpName.Tables[0].Rows.Count > 0)
                    {
                        EmpName = Convert.ToString(ds_EmpName.Tables[0].Rows[0]["Employee Name"]);
                        MailID = Convert.ToString(ds_EmpName.Tables[0].Rows[0]["Emailid"]);
                    }
                    if (MailID == null || MailID == "")
                    {
                        isTriggered = 1;
                    }
                }
            }
            else
            {
                isTriggered = -1;
            }
        }
        if (frm != "")
        {
            if (isTriggered != 1 && isTriggered != -1)
            {
                dtTableScript = objLeaveApplicationEventData.GetEmailScripts(frm);
                if (dtTableScript != null)
                {
                    if (dtTableScript.Rows.Count > 0)
                    {
                        isTriggered = sendEmail(frm, EmpName, Convert.ToString(dtTableScript.Rows[0]["ScriptText"]));
                    }
                }
            }
        }
        return isTriggered;
    }
    private void GetmailServerDetails()
    {
        try
        {
            DataSet dsMailConfiguration = new DataSet();
            dsMailConfiguration = objDAL.ExecuteDataSet("Proc_TA_GetMailConfiguration");
            if (dsMailConfiguration != null)
            {
                if (dsMailConfiguration.Tables.Count > 0)
                {
                    if (dsMailConfiguration.Tables[0].Rows.Count > 0)
                    {
                        strSSLEnable = Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["SSLEnable"]);
                        strMailAuthentication = Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["MailAuthentication"]);
                        strMailAuthenticateUser = Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["MailAuthenticateUser"]);
                        strMailAuthenticatePassword = Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["MailAuthenticatePassword"]);
                        emailFrom = Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["FromEmailId"]);
                        strHost = Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["SMTPClientHost"]);
                        strSMTPPort = Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["SMTPPort"]);
                    }
                }
            }
        }
        catch
        {
            isTriggered = 2;
        }
    }
    public int sendEmail(string frm, string empname, string scriptText)
    {
        try
        {
            GetmailServerDetails();
            if (emailFrom != "" && strHost != "" && strSMTPPort != "")
            {
                MailMessage mailMessage = new MailMessage();
                System.Net.Mime.ContentType loTextType = new System.Net.Mime.ContentType("text/plain");
                System.Net.Mime.ContentType loHTMLType = new System.Net.Mime.ContentType("text/html");
                AlternateView loHTMLView = null;
                mailMessage.From = new MailAddress(emailFrom);
                mailMessage.Body = replaceBodyContent(scriptText, frm, empname);
                mailMessage.To.Add(MailID);
                mailMessage.Subject = subject;
                loHTMLView = AlternateView.CreateAlternateViewFromString(mailMessage.Body, loHTMLType);
                mailMessage.AlternateViews.Add(loHTMLView);
                SmtpClient loSMTPServer = new SmtpClient(strSMTPPort, Convert.ToInt32(strSMTPPort));
                loSMTPServer.Host = strHost;
                loSMTPServer.Port = Convert.ToInt32(strSMTPPort);
                if (Convert.ToString(strMailAuthentication).ToLower() == "true")
                {
                    strMailAuthenticatePassword = Cryptographys.Cryptography.Decrypt(strMailAuthenticatePassword, "TimecheckPhaseI");
                }
                loSMTPServer.Port = Convert.ToInt32(strSMTPPort);
                if (Convert.ToString(strSSLEnable).ToLower() == "true")
                {
                    loSMTPServer.EnableSsl = true;
                }
                else
                {
                    loSMTPServer.EnableSsl = false;
                }
                if (Convert.ToString(strMailAuthentication).ToLower() == "false")
                {
                    loSMTPServer.UseDefaultCredentials = true;
                }
                else
                {
                    loSMTPServer.UseDefaultCredentials = false;
                }
                mailMessage.IsBodyHtml = true;
                if (Convert.ToString(strMailAuthentication).ToLower() == "true")
                {
                    System.Net.ServicePointManager.ServerCertificateValidationCallback = delegate (object s,
                 System.Security.Cryptography.X509Certificates.X509Certificate certificate,
                 System.Security.Cryptography.X509Certificates.X509Chain chain,
                 System.Net.Security.SslPolicyErrors sslPolicyErrors)
                    {
                        return true;
                    };
                    loSMTPServer.Credentials = new System.Net.NetworkCredential(strMailAuthenticateUser, strMailAuthenticatePassword);
                    loSMTPServer.Send(mailMessage);
                }
                else
                {
                    loSMTPServer.DeliveryMethod = SmtpDeliveryMethod.Network;
                    loSMTPServer.Send(mailMessage);
                }
            }
            else
            {
                isTriggered = 2;
            }
        }
        catch (Exception ex)
        {
            string exception = ex.ToString();
            isTriggered = 2;
        }
        return isTriggered;
    }
    private string replaceBodyContent(string bodycontent, string frm, string empname)
    {
        if (bodycontent != "" && bodycontent != null)
        {
            switch (frm)
            {
                case "ResetPassword":
                    bodycontent = bodycontent.Replace("<<ltr_rtl>>", rm.GetString("Direction", objCultureInfo));
                    bodycontent = bodycontent.Replace("<<lblusername>>", EmpName.ToUpper());
                    bodyContentFinal = bodycontent;
                    subject = "Timecheck Reset Password";
                    break;
                case "Index":
                    bodycontent = bodycontent.Replace("<<ltr_rtl>>", rm.GetString("Direction", objCultureInfo));
                    bodycontent = bodycontent.Replace("<<lblusername>>", EmpName.ToUpper());
                    bodyContentFinal = bodycontent;
                    subject = "Timecheck Reset Password";
                    break;
                default:
                    break;
            }
        }
        return bodyContentFinal;
    }
    public bool SendMailCompOff(string strEmployeeEmailId, string ToMailId, string SanctionMailId, string Employee_Code_Id, string EmployeeName, string ApplicationDate, string DutyDate, string InTime, string OutTime, string DayWorked, string WorkedHours, string Reason, string Status, string strlevelName, string strAddorModify)
    {
        
        string strFromEmailId = string.Empty;
        string strSourceLanguage;
        strSourceLanguage = Convert.ToString(HttpContext.Current.Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(strSourceLanguage, System.Reflection.Assembly.Load("App_GlobalResources"));
        objCultureInfo = Thread.CurrentThread.CurrentCulture;
        MailMessage mailMessage = new MailMessage();
        System.Net.Mime.ContentType loTextType = new System.Net.Mime.ContentType("text/plain");
        System.Net.Mime.ContentType loHTMLType = new System.Net.Mime.ContentType("text/html");
        string strMailStatus = string.Empty;
        AlternateView loHTMLView = null;
        try
        {
            string scriptText;
            DataTable dtTableScript = new DataTable();
            string ScriptType = "CompOff Application form";
            dtTableScript = objLeaveApplicationEventData.GetEmailScripts(ScriptType);
            scriptText = Convert.ToString(dtTableScript.Rows[0]["ScriptText"]);
            if (HttpContext.Current.Session["loginEmailId"] != null && Convert.ToString(HttpContext.Current.Session["loginEmailId"]) != string.Empty)
            {
                mailMessage.From = new MailAddress(Convert.ToString(HttpContext.Current.Session["loginEmailId"]));
                strFromEmailId = Convert.ToString(HttpContext.Current.Session["loginEmailId"]);
            }
            else
            {
                mailMessage.From = new MailAddress(ConfigurationManager.AppSettings.Get("FromId"));
                strFromEmailId = Convert.ToString(ConfigurationManager.AppSettings.Get("FromId"));
            }

            if (Status == "Pending")
            {
                if (ToMailId != string.Empty)
                {
                    mailMessage.To.Add(new MailAddress(ToMailId));
                }
                if (strEmployeeEmailId != string.Empty)
                {
                    mailMessage.CC.Add(new MailAddress(strEmployeeEmailId));
                }
            }
            else if (Status == "Delete" || Status == "Approved" || Status == "Rejected")
            {
                if (strEmployeeEmailId != string.Empty)
                {
                    mailMessage.To.Add(new MailAddress(strEmployeeEmailId));
                }
                if (ToMailId != string.Empty)
                {
                    mailMessage.CC.Add(new MailAddress(ToMailId));
                }
            }
            else if (Status == "Forwarded")
            {
                if (SanctionMailId != string.Empty)
                {
                    mailMessage.To.Add(new MailAddress(SanctionMailId));
                }
                if (strEmployeeEmailId != string.Empty)
                {
                    mailMessage.CC.Add(new MailAddress(strEmployeeEmailId));
                }
            }
            //else if(Status == "Approved")
            //{
            //    if (strEmployeeEmailId != string.Empty)
            //    {
            //        mailMessage.To.Add(new MailAddress(strEmployeeEmailId));
            //    }
            //    if (ToMailId != string.Empty)
            //    {
            //        mailMessage.CC.Add(new MailAddress(ToMailId));
            //    }
            //}
            
            //if (HttpContext.Current.Session["loginEmailId"] != null && HttpContext.Current.Session["loginEmailId"].ToString() != string.Empty)
            //{
            //    if (SanctionMailId != ToMailId)
            //    {
            //        if (Status != "Forwarded")
            //        {
            //            if (HttpContext.Current.Session["loginEmailId"].ToString() == SanctionMailId)
            //            {
            //                if (strEmployeeEmailId != string.Empty)
            //                {
            //                    mailMessage.To.Add(new MailAddress(strEmployeeEmailId));
            //                }
            //                if (ToMailId != string.Empty)
            //                {
            //                    mailMessage.CC.Add(new MailAddress(ToMailId));
            //                }
            //            }
            //            if (HttpContext.Current.Session["loginEmailId"].ToString() == ToMailId)
            //            {
            //                if (strEmployeeEmailId != string.Empty)
            //                {
            //                    mailMessage.To.Add(new MailAddress(strEmployeeEmailId));
            //                }
            //            }
            //        }
            //    }
            //    else
            //    {
            //        if (Status != "Forwarded")
            //        {
            //            if (strEmployeeEmailId != string.Empty)
            //            {
            //                mailMessage.To.Add(new MailAddress(strEmployeeEmailId));
            //            }
            //        }
            //    }
            //}
            //else
            //{
            //    if (Status != "Forwarded")
            //    {
            //        if (Status == "Rejected")
            //        {
            //            if (strEmployeeEmailId != string.Empty)
            //            {
            //                mailMessage.To.Add(new MailAddress(strEmployeeEmailId));
            //            }
            //            if (ToMailId != string.Empty)
            //            {
            //                mailMessage.CC.Add(new MailAddress(ToMailId));
            //            }
            //        }
            //        else if (Status == "Delete")
            //        {
            //        }
            //        else
            //        {
            //            if (strEmployeeEmailId != string.Empty)
            //            {
            //                mailMessage.To.Add(new MailAddress(strEmployeeEmailId));
            //            }
            //            if (ToMailId != string.Empty)
            //            {
            //                mailMessage.CC.Add(new MailAddress(ToMailId));
            //            }
            //        }
            //    }
            //}





            if (strAddorModify == "Add" || strAddorModify == "Sanction")
            {
                mailMessage.Subject = rm.GetString("email_CompOffApplicationForm", objCultureInfo) + " - " + ApplicationDate + " | " + Employee_Code_Id + " - " + EmployeeName + " | " + strlevelName + " - " + Status;
            }
            else
            {
                mailMessage.Subject = rm.GetString("email_CompOffApplicationForm", objCultureInfo) + " - " + ApplicationDate + " | " + Employee_Code_Id + " - " + EmployeeName + " | " + strlevelName + " - " + "Modify";
            }
            mailMessage.Body = scriptText.Replace("<<lblCompform>>", rm.GetString("email_CompOffApplicationForm", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<ltr_rtl>>", rm.GetString("Direction", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeID>>", rm.GetString("email_EmployeeId", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<EmployeeID>>", Employee_Code_Id);
            mailMessage.Body = mailMessage.Body.Replace("<<lblEmployeeName>>", rm.GetString("email_EmployeeName", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<EmployeeName>>", EmployeeName);
            mailMessage.Body = mailMessage.Body.Replace("<<lblApplicationDate>>", rm.GetString("email_CompOffApplicationDate", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<ApplicationDate>>", ApplicationDate);
            mailMessage.Body = mailMessage.Body.Replace("<<lblDutyDate>>", rm.GetString("lbl_DutyDate", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<DutyDate>>", DutyDate);
            mailMessage.Body = mailMessage.Body.Replace("<<lblInTime>>", rm.GetString("ManualTimeEntry_In_Time", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<Intime>>", InTime);
            mailMessage.Body = mailMessage.Body.Replace("<<lblOutTime>>", rm.GetString("ManualTimeEntry_Out_Time", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<OutTime>>", OutTime);
            mailMessage.Body = mailMessage.Body.Replace("<<lblDayWorked>>", rm.GetString("lbl_Dayworked", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<DayWorked>>", DayWorked);
            mailMessage.Body = mailMessage.Body.Replace("<<lblWorkedHours>>", rm.GetString("lbl_ExtraWorkedHrs", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<WorkedHours>>", WorkedHours);
            mailMessage.Body = mailMessage.Body.Replace("<<lblReason>>", rm.GetString("email_Reason", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<Reason>>", Reason);
            //if(Status== "Delete")
            //{
            //    mailMessage.Body = mailMessage.Body.Replace("<<disvalue>>", "none");
            //}
            //else
            //{
            //    mailMessage.Body = mailMessage.Body.Replace("<<lblReason>>", rm.GetString("email_Reason", objCultureInfo));
            //    mailMessage.Body = mailMessage.Body.Replace("<<Reason>>", Reason);
            //}
            mailMessage.Body = mailMessage.Body.Replace("<<lblStatus>>", rm.GetString("email_Status", objCultureInfo));
            mailMessage.Body = mailMessage.Body.Replace("<<Status>>", Status);
            //mailMessage.Body = mailMessage.Body.Replace("<<lbltosession>>", rm.GetString("email_ToDate", objCultureInfo));
            //mailMessage.Body = mailMessage.Body.Replace("<<reason>>", strReason);
            //mailMessage.Body = mailMessage.Body.Replace("<<lblreason>>", rm.GetString("email_Reason", objCultureInfo));
            cls_Common objcom = new cls_Common();
            objcom.SendMail(mailMessage);
        }
        catch (Exception ex)
        {
            blnCheckEmail = false;
            //objLeaveApplicationEventData.InsertLeaveApplicationDetailsInEmailTrigger(intLeaveApplicationId, strFromEmailId, ToMailId, strEmployeeEmailId, rm.GetString("email_LeaveApplicationForm", objCultureInfo) + " - " + ApplicationDate + " | " + Employee_Code_Id + " - " + EmployeeName + " | " + strlevelName + " - " + strMailStatus, Convert.ToString(mailMessage.Body), "", "LeaveApplication");
        }
        return blnCheckEmail;
    }
}

