using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
/// <summary>
/// Summary description for MultiLingualEventData
/// </summary>
public class MultiLingualEventData
{
    DataSet ds_LanguageDetails = new DataSet();
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    public DataSet GetActiveLanguageDetails()
    {
        try
        {
            ds_LanguageDetails = objDataAccess.ExecuteDataSet("Proc_TA_GetActiveLanguageDetails");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LanguageDetails;
    }
    public void InsertUpdateActiveLanguage(int Language_Id)
    {
        try
        {
            htable.Clear();
            htable.Add("@Language_Id", Language_Id);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_InsertUpdateActiveLanguage");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet GetLanguageDetails()
    {
        try
        {
            ds_LanguageDetails = objDataAccess.ExecuteDataSet("Proc_TA_GetLanguageDetails");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LanguageDetails;
    }
    public void InsertorUpdateEmployeeLingual(int LanguageId, int EmployeeId)
    {
        try
        {
            htable.Clear();
            htable.Add("@LanguageId", LanguageId);
            htable.Add("@EmployeeId", EmployeeId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_InsertorUpdateEmployeeLingual");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet GetEmployeeLingual(int EmployeeId)
    {
        try
        {
            htable.Clear();
            htable.Add("@EmployeeId", EmployeeId);
            ds_LanguageDetails = objDataAccess.GetStoredProcCommand("Proc_TA_GetEmployeeLingual", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LanguageDetails;
    }
}