namespace Cryptographys
{
    using System;
    using System.IO;
    using System.Text;
    using System.Security.Cryptography;
    using System.Configuration;
    using System.Diagnostics;
    public class Cryptography
    {
        public static string Decrypt(string str)
        {
            string[] full = str.Split(",".ToCharArray());
            str = full[0];
            byte[] buffer;
            str = str.Replace(" ", "+");
            buffer = Convert.FromBase64String(str);
            PasswordDeriveBytes pdb = new PasswordDeriveBytes("", new byte[] { 0x51, 0x76, 0x61, 0x6e, 0x20, 0x4d, 0x65, 0x64, 0x76, 0x65, 0x64, 0x65, 0x76 });
            return Encoding.Unicode.GetString(Decrypt(buffer, pdb.GetBytes(32), pdb.GetBytes(16)));
        }
        private static byte[] Decrypt(byte[] byteArrayToEncrypt, byte[] Key, byte[] IV)
        {
            MemoryStream memoryStream = new MemoryStream();
            Rijndael rijndael = Rijndael.Create();
            rijndael.Key = Key;
            rijndael.IV = IV;
            CryptoStream cryptoStream;
            cryptoStream = new CryptoStream(memoryStream, rijndael.CreateDecryptor(), CryptoStreamMode.Write);
            cryptoStream.Write(byteArrayToEncrypt, 0, byteArrayToEncrypt.Length);
            cryptoStream.Close();
            byte[] returnArray = memoryStream.ToArray();
            memoryStream.Close();
            return returnArray;
        }


        public static string Decrypt(string stringToDecrypt, string sEncryptionKey)
        {
            byte[] key = { };
            byte[] IV = { 10, 20, 30, 40, 50, 60, 70, 80 };
            byte[] inputByteArray = new byte[stringToDecrypt.Length];
            try
            {
                key = Encoding.UTF8.GetBytes(sEncryptionKey.Substring(0, 8));
                DESCryptoServiceProvider des = new DESCryptoServiceProvider();
                inputByteArray = Convert.FromBase64String(stringToDecrypt);
                MemoryStream ms = new MemoryStream();
                CryptoStream cs = new CryptoStream(ms, des.CreateDecryptor(key, IV), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                Encoding encoding = Encoding.UTF8;
                return encoding.GetString(ms.ToArray());
            }
            catch (System.Exception ex)
            {
                //WriteErrorToEventLog("DataProcess", "Decrypt()" + "\r\n" + ex.Message);
                //return (string.Empty);
                throw ex;
            }
        }
        public static string Encrypt(string stringToEncrypt, string sEncryptionKey)
        {
            byte[] key = { };
            byte[] IV = { 10, 20, 30, 40, 50, 60, 70, 80 };
            byte[] inputByteArray;
            try
            {
                key = Encoding.UTF8.GetBytes(sEncryptionKey.Substring(0, 8));
                DESCryptoServiceProvider des = new DESCryptoServiceProvider();
                inputByteArray = Encoding.UTF8.GetBytes(stringToEncrypt);
                MemoryStream ms = new MemoryStream();
                CryptoStream cs = new CryptoStream(ms, des.CreateEncryptor(key, IV), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                return Convert.ToBase64String(ms.ToArray());
            }
            catch (System.Exception ex)
            {
                //WriteErrorToEventLog("DataProcess", "Encrypt()" + "\r\n" + ex.Message);
                throw ex;
            }
        }
        public static string GetDecryptedConnectionString()
        {
            try
            {
                string strEncryptedString = Convert.ToString(ConfigurationSettings.AppSettings["ConnectionString"]);
                string strDecryptedString = Cryptographys.Cryptography.Decrypt(strEncryptedString, "TimecheckPhaseI");
                return strDecryptedString;
            }
            catch (Exception ex)
            {
                //WriteErrorToEventLog("DataProcess", "GetDecryptedConnectionString()" + "\r\n" + ex.Message);
                throw ex;
            }
        }
        public static void WriteErrorToEventLog(string applicationName, string msg)
        {
            StackFrame CallStack = new StackFrame(1, true);
            int lineNumber = CallStack.GetFileLineNumber();
            string msg2 = CallStack.GetFileName() + "\r\n";
            msg2 += "Line: " + lineNumber.ToString() + "\r\n";
            msg2 += msg;
            if (!EventLog.SourceExists(applicationName))
            {
                EventLog.CreateEventSource(applicationName, "Application");
            }
            EventLog.WriteEntry(applicationName, msg2, EventLogEntryType.Error, lineNumber);
        }
    }
}